;==============================================================
; A-Team Music
;
; Source code in WLA-DX assembler dialect
;
; Converted from some unknown assembler (TASM?) by Maxim
; around the end of May, 2010
;
; Changes have been minimal wherever possible, leaving original
; code etc in comments.
; Additions should be marked with a "; M" comment.
;
; The original use of tabs seems quite messed up. The tab width
; seems to be 8 in some places, more (!) in others.
;==============================================================

; SMS memory map   ; M
.MEMORYMAP         ; M
DEFAULTSLOT 0      ; M
SLOTSIZE $4000     ; M
SLOT 0 $0000       ; M
SLOT 1 $4000       ; M
SLOT 2 $8000       ; M
SLOTSIZE $2000     ; M
SLOT 3 $c000       ; M
.ENDME             ; M

.ROMBANKMAP        ; M
BANKSTOTAL 2       ; M
BANKSIZE $4000     ; M
BANKS 2            ; M
.ENDRO             ; M

.bank 0 slot 0     ; M
.org $0000         ; M
    di             ; M
    im 1           ; M
    jp INITCOMP    ; M


;==============================================================
; Part 0 (0.PDS)
;==============================================================

***** 5 STAR AUDIO-DRIVER.

;-----------------------------------------------------------------------------
;SEGA MASTER SYSTEM/GAME GEAR - AUDIO-DRIVER
;
;CONCEPT & PROGRAMMING by JEROEN TEL / THE SONIC CIRCLE
;
;FOR EXCLUSIVE USE ONLY!
;-----------------------------------------------------------------------------
;
;Game/type		:THE A-TEAM / PAL
;By		:JEROEN TEL
;Format		:SEGA MASTERSYSTEM/GAME_GEAR
;Date		:29/09/1992
;
;P.D.S. Note: (ctrl) (f)=find (t)=find next (c)=copy (m)=move
;----------------------------------------------------------------------------------------------------------------------
;
;SPECIFICATIONS:
;
;To run the MUSIC & SOUNDEFFECTS, call SOUNDINIT to Initialise with
;the serial number of the 'audio'-piece plus the indicated channel-number
;in variable-pair DE. For example, calling the FIRST 'AUDIO'-PIECE (#01) on
;the FIRST CHANNEL (#00), etc.
;
;                  \/
;                  \/
;
;	LD	DE,#0100    ;D= AUDIO-PIECE #01  E= CHANNEL 00
;	CALL	SOUNDINIT	;INITIALISE
;	LD	DE,#0201	;D= AUDIO-PIECE #02		E= CHANNEL 01
;	CALL	SOUNDINIT	;INITIALISE
;	LD	DE,#0302	;ETC.
;	CALL	SOUNDINIT
;	LD	DE,#0403
;	CALL	SOUNDINIT
;
;ALL THE AUDIO-PIECES ARE SPECIFIED IN THE AUDIO-TABLE (Shift-F2 on PDS!)
;
;exmpl:AUDTABLE	dw CLEARAUD ; #00,#xx	(This STOPS any CHANNEL you want)
;				(important for stopping endless SFX!)
;
;The numbers after the ' dw NAME-X ;#Y #Z ' are resp. X=CHANNELNUMBER
;				               Y=AUDIO-PIECE-NR
;				               Z=CHANNELNUMBERIND.
;
;You can see how many channels (and which channels) are use by a piece of
;MUSIC or SOUNDEFFECTS. You can see that the CG_TITLE uses ALL the channels,
;because the is a CG_TITLE0, CG_TITLE1, CG_TITLE2, CG_TITLE3. The numbers
;stand for the channel-number.
;
;MOST soundeffects are played on ONE channel only, but as you can see in
;the AUDTABLE as well, there are soundeffects, that use both channel #02 & #03
;
;I think I've made my point on INITIALISATION now...
;
;To run the AUDIO-PIECES, call SOUNDPLAY with the required channel-number,
;(So you have to do it four times for four channels.), 50 times/second.
;
;example:	ld	DE,#0000	(indicate CHANNEL #00)
;	call	SOUNDPLAY	(play CHANNEL #00)
;	ld	DE,#0001	(indicate CHANNEL #01)
;	call	SOUNDPLAY	(play CHANNEL #01)
;etc.
;
;
; I used RAM from $0400-$0487
;
;
;Any questions... call me at PROBE.
;
;
; Best regards,
;
; JEROEN TEL.
;



;	SEND	COMPUTER0

.ORG $0038
	JP	INTCONTROL


.ORG $0066
	DI
	LD	SP,$DFF0
	JP	PDS

.ORG	$400

.define voictest		$00*4
.define stpindex		$01*4
.define seqindex		$02*4
.define seqposit		$03*4
.define repstcnt		$04*4
.define stepnumb		$05*4
.define spdcount		$06*4
.define spdcheck		$07*4
.define realplay		$08*4
.define noteinit		$09*4
.define realsoun		$0A*4
.define noteleng		$0B*4
.define realleng		$0C*4
.define realnote		$0D*4
.define lofrqwrd		$0E*4
.define hifrqwrd		$0F*4
.define tranbyte		$10*4
.define sfxtrans		$11*4
.define arpindex		$12*4
.define arpnumbo		$13*4
.define arpspeed		$14*4
.define arponoto		$15*4
.define gldspeed		$16*4
.define glddirec		$17*4
.define glddelay		$18*4
.define destnote		$19*4
.define vibdelay		$1A*4
.define vibindex		$1B*4
.define amplitud		$1C*4
.define ampindex		$1D*4
.define fx01		$1E*4
.define fx02		$1F*4
.define fx03		-2*4;$20*4           ; M bugfix: overflowed signed 8-bit range
.define lofrsame		-1*4;$21*4       ; M bugfix: overflowed signed 8-bit range

.define SCREEN1		$3000
.define SCREEN2		$3800

.define PDS		$B0

.define PAGEFLAG		$FFFC
.define PAGEAREA0		$FFFD
.define PAGEAREA1		$FFFE
.define PAGEAREA2		$FFFF

.define SLOTSEL		$3E
.define VDPCOM		$BF
.define VDPDATA		$BE
.define JOYPORT1		$DC
.define JOYPORT2		$DD
.define PSGPORT		$7F

.define BLACK		0

.define RED		%00000011
.define GREEN		%00001100
.define BLUE		%00110000

.define RED0		%00000001
.define RED1		%00000010
.define RED2		%00000011
.define RED3		%00010111

.define GREEN0		%00000100
.define GREEN1		%00001000
.define GREEN2		%00001100

.define BLUE0		%00010000
.define BLUE1		%00100000
.define BLUE2		%00110000

.define GREEN3	RED0|GREEN2|BLUE0
.define GREEN4	RED1|GREEN2|BLUE2

.define BLUE3	BLUE2|GREEN0|RED0
.define BLUE4	BLUE2|GREEN1|RED0
.define BLUE5	BLUE2|GREEN1|RED1
.define BLUE6	BLUE2|GREEN2|RED1

.define YELLOW0	RED0|GREEN0
.define YELLOW1	RED1|GREEN1
.define YELLOW2	RED2|GREEN2
.define YELLOW3	RED2|GREEN2|BLUE0

.define MAGENTA0	RED0|BLUE0
.define MAGENTA1	RED1|BLUE1
.define MAGENTA2	RED2|BLUE2

.define CYAN0		GREEN0|BLUE0
.define CYAN1		GREEN1|BLUE1
.define CYAN2		GREEN2|BLUE2

.define WHITE0	RED0|GREEN0|BLUE0
.define WHITE1	RED1|GREEN1|BLUE1
.define WHITE2	RED2|GREEN2|BLUE2

.define BROWN		RED1|GREEN0
.define ORANGE	RED2|GREEN1

INITCOMP
    DI
	LD	SP,$DFEF

	LD	A,($C000)
	AND	$E0
	OR	$08
	OUT	($3E),A
	LD	A,$0F
	OUT	($3F),A

	LD	A,%00000000
	LD	(PAGEFLAG),A
	LD	A,0
	LD	(PAGEAREA0),A
	LD	A,1
	LD	(PAGEAREA1),A
	LD	A,2
	LD	(PAGEAREA2),A

	LD	BC,$00D6		; no scrolling, norm sprites,
	CALL	SETVDPREG		; in vdp r0
	LD	BC,$01E0		; screen on etc
	CALL	SETVDPREG
	LD	BC,$02FF		; screen on etc
	CALL	SETVDPREG
	LD	BC,$05FF
	CALL	SETVDPREG
	LD	BC,$06FB
	CALL	SETVDPREG
	LD	BC,$07F0		; border 0 in 2nd bank of colours !!
	CALL	SETVDPREG
	LD	BC,$0AFF		; set interrupts( vblank only ! )
	CALL	SETVDPREG

	LD	HL,TEXTPALET
	CALL	SETCOLOURS

	LD	DE,$0000
	CALL	SOUNDINIT
	LD	DE,$0001
	CALL	SOUNDINIT
	LD	DE,$0002
	CALL	SOUNDINIT
	LD	DE,$0003
	CALL	SOUNDINIT

	EI

	CALL	CLS

	LD	BC,46*32
	LD	DE,$0000
	LD	HL,TEXTCHARS
	CALL	VRAMLDIR

	XOR	A
	LD	(ATNO),A
	LD	(SAMNO),A

	LD	IX,SOUNDTEXT
	CALL	PRS

--:/*$1*/	CALL	VBLANK
	CALL	VBLANK
	CALL	VBLANK

	LD	A,(ATNO)
	LD	(NUMBUFF+2),A
	LD	A,3
	LD	DE,6*64+19*2+$3800
	LD	HL,NUMBUFF
	CALL	DNUMBER
	LD	A,(SAMNO)
	LD	(NUMBUFF+2),A
	LD	A,3
	LD	DE,8*64+19*2+$3800
	LD	HL,NUMBUFF
	CALL	DNUMBER

	CALL	GKEYS
	LD	HL,(ATNO)
	BIT	0,E
	JP	Z,+ ;$2
	INC	H
+:/*$2*/	BIT	1,E
	JP	Z,+ ;$3
	INC	L
+:/*$3*/	BIT	2,E
	JP	Z,+ ;$4
	DEC	H
+:/*$4*/	BIT	3,E
	JP	Z,+ ;$5
	DEC	L
+:/*$5*/	LD	(ATNO),HL
	BIT	4,E
	JP	Z,++ ;$6

-:/*$50*/	CALL	GKEYS
	BIT	4,E
	JP	NZ,- ;$50

	LD	A,(MONOFF)
	XOR	1
	LD	(MONOFF),A
	JP	Z,+ ;$51

	LD	HL,SFXTAB0
	LD	DE,(ATNO)
	LD	D,0
	ADD	HL,DE
	LD	D,(HL)
	LD	E,$00
	DI
	call	SOUNDINIT
	EI
	LD	HL,SFXTAB1
	LD	DE,(ATNO)
	LD	D,0
	ADD	HL,DE
	LD	D,(HL)
	LD	E,$01
	DI
	call	SOUNDINIT
	EI
	LD	HL,SFXTAB2
	LD	DE,(ATNO)
	LD	D,0
	ADD	HL,DE
	LD	D,(HL)
	LD	E,$02
	DI
	call	SOUNDINIT
	EI
	LD	HL,SFXTAB3
	LD	DE,(ATNO)
	LD	D,0
	ADD	HL,DE
	LD	D,(HL)
	LD	E,$03
	DI
	call	SOUNDINIT
	EI
	JP	-- ;$1

+:/*$51*/	DI
	LD	DE,$0000
	CALL	SOUNDINIT
	LD	DE,$0001
	CALL	SOUNDINIT
	LD	DE,$0002
	CALL	SOUNDINIT
	LD	DE,$0003
	CALL	SOUNDINIT
	EI
	JP	-- ;$1

++:/*$6*/	BIT	5,E
	JP	Z,-- ;$1

	DI
	LD	DE,$0000
	CALL	SOUNDINIT
	LD	DE,$0001
	CALL	SOUNDINIT
	LD	DE,$0002
	CALL	SOUNDINIT
	LD	DE,$0003
	CALL	SOUNDINIT
	EI
	LD	HL,SAMTAB
	LD	A,(SAMNO)
	ADD	A,A
	ADD	A,A
	LD	E,A
	LD	D,0
	ADD	HL,DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	INC	HL
	LD	C,(HL)
	INC	HL
	LD	B,(HL)
	LD	HL,(SAMSPEED)
	EX	DE,HL
	CALL	VBLANK
	CALL	SAMPLAY
	JP	-- ;$1

SAMPLAY	DI
	LD	A,%10011111
	OUT	(PSGPORT),A
	LD	A,%10111111
	OUT	(PSGPORT),A
	LD	A,%11011111
	OUT	(PSGPORT),A
	LD	A,%11111111
	OUT	(PSGPORT),A

--: /*$1*/	PUSH	HL
	EXX
	POP	HL

	LD	A,(HL)
	SRL	A
	SRL	A
	SRL	A
	SRL	A
	or	%10110000
	out	(PSGPORT),a
	ADD	A,%00100000
	OUT	(PSGPORT),A
	EXX

	INC	HL

	LD	A,E
-:/*$2*/	DEC	A
	JP	NZ,- ;$2

	DEC	BC
	LD	A,B
	OR	C
	JP	NZ,-- ;$1

	EI
	RET


INTCONTROL	DI

	PUSH	AF
	push BC
	push DE
	push HL
	push IX

	IN	A,(VDPCOM)		; get int. status

	BIT	7,A
	JP	Z,+ ;$EXIT		; jump if not vblank

	ld	de,$0000
	call	soundplay
	ld	de,$0001
	call	soundplay
	ld	de,$0002
	call	soundplay
	ld	de,$0003
	call	soundplay

	LD	A,$80
	LD	(INTFLAG),A

+: ;$EXIT
    POP	IX
	pop HL
	pop DE
	pop BC
	pop AF

	EI
	RET


;DON'T USE ANYTHING TILL HERE, JUST TO RUN THE AUDIO FOR YOU.





SOUNDINIT	jp	AUDIOIN	;Jump to channel init-routine with A & X (once)
soundplay	jp	AUDIOPL	;Jump to channel play-routine with X     (50t/s)

; entry :- d=sequence no.
;	e=channel/index no. (=x)
;

AUDIOIN	ld	ix,VARIABLES+8 ; M bugfix: overflowed signed 8-bit range
	ld	b,0
	ld	c,e
	add	ix,bc

	sla	d	;CHANNEL INITIALISATION for voice X
	ld	(ix+seqposit),d
	ld	(ix+stpindex),sex-s00-1
	xor	a
	ld	(ix+seqindex),a
 	ld	(ix+spdcheck),a
	ld	(ix+spdcount),a
	ld	(ix+noteinit),a
	ld	(ix+tranbyte),a
	ld	(ix+stepnumb),a
	ld	(ix+ampindex),a
	ld	(ix+amplitud),a
	ld	(ix+ -1*4/*lofrsame*/ ),a	; M WLA-DX doesn't support using a symbol here :(
	ld	(ix+sfxtrans),a
	inc	a
	ld	(ix+voictest),a
	ld	(ix+repstcnt),a
	ld	(ix+noteleng),a

; enable voice

	ret

AUDIOPL	ld	ix,VARIABLES+8 ; M bugfix: overflowed signed 8-bit range
	ld	b,0
	ld	c,e
	add	ix,bc

	ld	a,(ix+voictest)		;CHECK IF THIS IS VOICE 1,2,3 or 4
	or	a
       	ret	z

DOVOICE
	ld	a,(ix+amplitud)
	xor	%00001111
	ld	l,a
	ld	a,e
	add	a,a
	add	a,a
	add	a,a
	add	a,a
	add	a,a		;TRANSFER VALUES TO SOUND-CHIP
	or	%10010000
	or	l
	out	(PSGPORT),a

nonewamp

/*$dv1*/	ld	a,e
	cp	$03
	jp	z,+ ;$dv2

; set low frequency reg.
	add	a,a
	add	a,a
	add	a,a
	add	a,a
	add	a,a
	or	%10000000
	ld	l,a
	ld	a,(ix+lofrqwrd)

	and	%00001111
	or	l
	out	(PSGPORT),a

	ld	l,(ix+lofrqwrd)
	srl	l
	srl	l
	srl	l
	srl	l
	ld	a,(ix+hifrqwrd)
	add	a,a
	add	a,a
	add	a,a
	add	a,a
	and	%00110000
	or	l
	out	(PSGPORT),a
	jp	SPDHDL1

+: ;$dv2
	ld	a,(ix+lofrqwrd)
	cp	(ix+ -1*4/*lofrsame*/ )	  ; M WLA-DX doesn't support using a symbol here :(
	jp	z,SPDHDL1
	ld	(ix+ -1*4/*lofrsame*/ ),a	  ; M WLA-DX doesn't support using a symbol here :(
	or	%11100000
	out	(PSGPORT),a

SPDHDL1	xor	a		;Speedroutine (two speed bytes)
	ld	(ix+realplay),a
	dec	(ix+spdcount)
	jp	p,SPDHDX1
	ld	a,(ix+spdcheck)
	xor	$ff
	ld	(ix+spdcheck),a
	jp	p,SECONS1
	ld	c,(ix+seqposit)
	ld	b,0
	ld	hl,seqtabes+$00
	add	hl,bc
	ld	a,(hl)
	jp	SPDSET1

SECONS1	ld	c,(ix+seqposit)
	ld	b,0
	ld	hl,seqtabes+$01
	add	hl,bc
	ld	a,(hl)

SPDSET1	ld	(ix+spdcount),a
	ld	a,$ff
	ld	(ix+realplay),a

SPDHDX1	ld	a,(ix+realplay)		;check if new leng subtraction necessary
	or	a
	jp	p,NOSTPH1

AUDIPL1	dec	(ix+noteleng)		;decrease speed, if zero then stephandle
	jp	z,STPHDL1

NOSTPH1	ld	a,(ix+realnote)		;check realnote on pause, no FX
	cp	$ff
	call	nz,FXPLAY1

NOFXPL1	xor	a		;clear noteinit
	ld	(ix+noteinit),a	;
	ret			;

STPHDL1	ld	c,(ix+stepnumb)		;What step to take
	ld	b,0
	ld	hl,stptablo
	add	hl,bc
	ld	a,(hl)
	ld	(ssslo),a
	ld	hl,stptabhi
	add	hl,bc
	ld	a,(hl)
	ld	(ssshi),a

	xor	a		;reset glide (if not reached dest. note)
	ld	(ix+gldspeed),a

	ld	c,(ix+stpindex)		;read step-index
	ld	b,0
	ld	hl,(ssslo)
	add	hl,bc
	ld	a,(hl)
	cp	$ff		;step check on end
	jr	z,SEQHDL1		;yes, goto sequence-handle
	jp	STPHD12		;no, goto stephandle 02

SEQHDL1	dec	(ix+repstcnt)		;check if step repeats
	jr	z,REALSQ1		;no, goto real sequence-handle
	xor	a		;yes, reset index & do last step again
	ld	(ix+stpindex),a	;
	ld	c,a			;
	ld	b,0
	ld	hl,(ssslo)
	add	hl,bc
	ld	a,(hl)
	jp	STPHD12		;

REALSQ1	ld	c,(ix+seqposit)		;what sequence to take
	ld	b,0
	ld	hl,AUDTABLE+$00
	add	hl,bc
	ld	a,(hl)
	ld	(ssslo),a		;
	ld	hl,AUDTABLE+$01
	add	hl,bc
	ld	a,(hl)
	ld	(ssshi),a		;

	ld	c,(ix+seqindex)		;read sequence-index
	ld	b,0
	ld	hl,(ssslo)
	add	hl,bc
	ld	a,(hl)
	cp	$ff		;check sequence on end-repeat
	jr	nz,SEQHD12		;
	inc	c			;
	ld	b,0
	ld	hl,(ssslo)
	add	hl,bc
	ld	a,(hl)
	ld	(ix+seqindex),a
	ld	c,a			;
	ld	b,0
	ld	hl,(ssslo)
	add	hl,bc
	ld	a,(hl)
	jp	SEQHD15		;goto next sequence

SEQHD12	cp	$fe		;check sequence on end-real
	jr	nz,SEQHD13		;
	xor	a		;yes, disable voice
	ld	(ix+voictest),a	;
	ret

SEQHD13	cp	$fc		;!!!! DO THE FADE! GODDAMNED !!!!
	jr	nz,SEQHD15		;!!!! still to be programmed !!!!

SEQHD15	cp	$80		;note transpose	check
	jr	c,SEQHD16
       	and	$7f
	ld	(ix+tranbyte),a
	inc	c
	ld	b,0
	ld	hl,(ssslo)
	add	hl,bc
	ld	a,(hl)
	or	a
	jp	m,NONWSTP
	cp	$80
   	jr	nc,NONWSTP

SEQHD16
;	cp	$70		;sfix transpose	check
;	jr	c,SEQHD17
;	and	$0f
;	ld	(ix+sfxtrans),a
;	inc	c
;	ld	b,0
;	ld	hl,(ssslo)
;	add	hl,bc
;	ld	a,(hl)

SEQHD17
;	cp	$60		;repeat step check
;	jr	c,SEQHD19
;	and	$0f
;	ld	(ix+repstcnt),a
;	inc	c
;	ld	b,0
;	ld	hl,(ssslo)
;	add	hl,bc
;	ld	a,(hl)

SEQHD19	ld	(ix+stepnumb),a	;set step & clear stepindex
	inc	c
NONWSTP	ld	a,c
	ld	(ix+seqindex),a
	inc	(ix+repstcnt)		;make sure step plays at least once
	xor	a
	ld	(ix+stpindex),a
	jp	STPHDL1		;back to step-handle

STPHD12 	cp	$fd		;glide check in step
	jr	nz,STPHD14
	inc	c
	ld	b,0
	ld	hl,(ssslo)
	add	hl,bc
	ld	a,(hl)
	ld	(ix+gldspeed),a
	inc	c
	ld	b,0
	ld	hl,(ssslo)
	add	hl,bc
	ld	a,(hl)
	add	a,(ix+tranbyte)
	ld	(ix+realnote),a
	inc	c
	ld	b,0
	ld	hl,(ssslo)
	add	hl,bc
	ld	a,(hl)
	add	a,(ix+tranbyte)
	ld	(ix+destnote),a
	inc	c
	jp	NONEWN1

STPHD14	cp	$e0		;pause check
	jr	c,STPHD15
	and	$1f
	ld	(ix+realleng),a
	ld	a,$ff
	ld	(ix+realnote),a
       	xor	a
	ld	(ix+amplitud),a
	inc	c
	ld	a,c
	ld	(ix+stpindex),a
	jp	PAUSEX1

STPHD15	cp	$c0		;sound check
	jr	c,STPHD16
	add	a,(ix+sfxtrans)
	sla	a
	sla	a
	ld	(ix+realsoun),a
	inc	c
	ld	b,0
	ld	hl,(ssslo)
	add	hl,bc
	ld	a,(hl)
	cp	$fd
	jr	z,STPHD12
	cp	$c0
	jr	nc,NONEWN1

STPHD16	cp	$80		;length check
	jr	c,STPHD17
	and	$7f
	ld	(ix+realleng),a
	inc	c
	ld	b,0
	ld	hl,(ssslo)
	add	hl,bc
	ld	a,(hl)
	cp	$fd
	jr	z,STPHD12
	cp	$80
	jr	nc,NONEWN1

STPHD17	cp	$60		;arp check
	jr	c,STPHD18
	and	$1f
	ld	(ix+arpnumbo),a
	inc	c
	ld	b,0
	ld	hl,(ssslo)
	add	hl,bc
	ld	a,(hl)
	cp	$60
	jr	nc,NONEWN1

STPHD18	add	a,(ix+tranbyte)	;set note + note transpose
	ld	(ix+realnote),a
	inc	c
NONEWN1	ld	a,c
	ld	(ix+stpindex),a		;update step-index

	inc	(ix+noteinit)		;first init has been done
	ld	c,(ix+realsoun)

	ld	a,e
	cp	$03
	jp	nz,NONEWPL
	ld	b,0
	ld	hl,soundfix+$00
	add	hl,bc
	ld	a,(hl)		;check if new noise to be set
	ld	(noisenabl),a

NONEWPL	ld	b,0
	ld	hl,soundfix+$01
	add	hl,bc
	ld	a,(hl)		;set vibrato-byte into fx01 & set effects (arp, etc)
	ld	(ix+fx01),a		;
	ld	b,0
	ld	hl,soundfix+$02
	add	hl,bc
	ld	a,(hl)		;set vibdelay into fx02
	ld	(ix+fx02),a		;

NONEWG1	ld	b,0
	ld	hl,soundfix+$03
	add	hl,bc
	ld	a,(hl)		;set effect-values into fx03
	ld	(ix+ -2*4 /*fx03*/ ),a		;

	ld	a,e
	cp	$03
	jp	z,ITSFOR4

	ld	c,(ix+realnote)	;Read realnote as index
	ld	b,0
	ld	hl,frqtable
	add	hl,bc
	add	hl,bc
	ld	a,(hl)	 	;Low-frequency read	 <bit 7-0>
	ld	(ix+lofrqwrd),a	;
	inc	hl
	ld	a,(hl)
        	ld	(ix+hifrqwrd),a	;HF set
	jp	PAUSEX1

ITSFOR4	ld	a,(ix+realnote)
	ld	(ix+lofrqwrd),a

PAUSEX1	ld	a,(ix+realleng)
       	ld	(ix+noteleng),a
	ret

FXPLAY1 	ld	a,(ix+noteinit)
	or	a
	jp	z,PLAYFXR

INTPLA1	ld	a,(ix+gldspeed)
	or	a
	jr	z,FXPLA12
	ld	c,a
	srl	a
	srl	a
	srl	a
	srl	a
	ld	(ix+glddelay),a
	ld	a,c
	and	$0f
	ld	(ix+gldspeed),a

	ld	a,(ix+realleng)
	sub	(ix+glddelay)
	ld	(ix+glddelay),a
	ld	a,(ix+realnote)
	sub	(ix+destnote)
	ld	(ix+glddirec),a

FXPLA12	xor	a
      	ld	(ix+ampindex),a
	ld	(ix+vibindex),a
       	ld	(ix+arpindex),a

	ld	a,(ix+fx02)
	srl	a
	srl	a
	srl	a
	srl	a
	ld	(ix+vibdelay),a
	ld	a,(ix+realleng)
	sub	(ix+vibdelay)
	jr	nc,REFIX01
	ld	a,(ix+fx01)
	and	$f0
	ld	(ix+fx01),a
	ld	a,(ix+realleng)
REFIX01	ld	(ix+vibdelay),a
EXITIN1	jp	NOVIB01

PLAYFXR	ld	a,(ix+realleng)	;Check if The REAL Notelength is 1
	cp	$1
	jp	z,+ ;$p1		;If So, Do NOT Cut Note Off At End

	ld	a,(ix+noteleng)
	cp	$01
	jp	nz,+ ;$P1
	ld	a,(ix+spdcount)	;!
	cp	$01		;!
	jp	nc,+ ;$p1		;!
	ld	(ix+amplitud),$00
	jp	NOAMPL1
+: ;$P1
	ld	a,(ix+ -2*4 /*fx03*/ )		  ;amplitude routine
       	and	$7f
       	ld	c,a
	ld	b,0
	ld	hl,amptabl
	add	hl,bc
	ld	a,(hl)
       	ld	(ssslo),a
	ld	b,0
	ld	hl,amptabh
	add	hl,bc
	ld	a,(hl)
       	ld	(ssshi),a

       	ld	c,(ix+ampindex)
	ld	b,0
	ld	hl,(ssslo)
	add	hl,bc
	ld	a,(hl)

 	cp	$fe
       	jr	z,NOAMPL1
       	ld	(ix+amplitud),a
       	inc	(ix+ampindex)
NOAMPL1

GLIDE1	ld	c,(ix+gldspeed)	  	;glide routine
	ld	a,c
	or	a
	jr	z,NOGLD12
	ld	a,(ix+glddelay)
	cp	(ix+noteleng)
	jr	c,NOGLD12

	ld	c,(ix+glddirec)
	ld	a,c
	or	a
	jp	m,DOWNGL1

	ld	a,(ix+lofrqwrd)
	add	a,(ix+gldspeed)
	ld	(ix+lofrqwrd),a
	jr	nc,CHECKV1
       	inc	(ix+hifrqwrd)

CHECKV1	ld	c,(ix+destnote)
	ld	b,0
	ld	hl,frqtable
	add	hl,bc
	add	hl,bc
	sub	(hl)
	jr	c,NOGLD01
	jr	FROTER1

DOWNGL1	ld	a,(ix+lofrqwrd)
	sub	(ix+gldspeed)
	ld	(ix+lofrqwrd),a
	jr	nc,CHECKV2
	dec	(ix+hifrqwrd)

CHECKV2 	ld	c,(ix+destnote)
	ld	b,0
	ld	hl,frqtable
	add	hl,bc
	add	hl,bc
	sub	(hl)
	jr	nc,NOGLD01

FROTER1	ld	a,c
	ld	(ix+realnote),a
	ld	b,0
	ld	hl,frqtable
	add	hl,bc
	add	hl,bc
	ld	a,(hl)
       	ld	(ix+lofrqwrd),a
	inc	hl
       	ld	a,(hl)
       	ld	(ix+hifrqwrd),a

	xor	a
	ld	(ix+gldspeed),a
NOGLD01	jp	NOVIB01
NOGLD12

VIBRA01	ld	a,(ix+fx01)	 	  ;vibrato routine
	and	$0f
	jr	z,NOVIB01
	ld	a,(ix+vibdelay)
	cp	(ix+noteleng)
	jr	c,NOVIB01

	ld	a,(ix+fx01)
	and	$0f
	ld	c,a
	ld	b,0
	ld	hl,vibtabl-1
	add	hl,bc
	ld	a,(hl)
	ld	(ssslo),a
	ld	b,0
	ld	hl,vibtabh-1
	add	hl,bc
	ld	a,(hl)
	ld	(ssshi),a

	ld	c,(ix+vibindex)
	ld	b,0
	ld	hl,(ssslo)
	add	hl,bc
	ld	a,(hl)
	cp	$80
	jr	nz,VIB01
	ld	c,$00
VIB01	ld	b,0
	ld	hl,(ssslo)
	add	hl,bc
	ld	a,(hl)
	or	a
	jp	p,UPVIBOS
	xor	$ff
	add	a,$01
	ld	(ssslo),a
	ld	a,(ix+lofrqwrd)
	ld	hl,ssslo
	sub	(hl)
	ld	(ix+lofrqwrd),a
	jr	nc,NOHIGH1
	dec	(ix+hifrqwrd)
NOHIGH1	jp	VIBNO01

UPVIBOS	ld	a,(ix+lofrqwrd)
	ld	b,0
	ld	hl,(ssslo)
	add	hl,bc
	add	a,(hl)
	ld	(ix+lofrqwrd),a
	jr	nc,NOHIGH2
       	inc	(ix+hifrqwrd)
NOHIGH2
VIBNO01	inc	c
	ld	a,c
	ld	(ix+vibindex),a
NOVIB01

ARPEG01	ld	a,(ix+fx01)		;arpeggio routine
	and	$40
	jp	z,NOARP01
	ld	c,(ix+arpnumbo)
	ld	b,0
	ld	hl,arptablo
	add	hl,bc
	ld	a,(hl)
	ld	(ssslo),a
	ld	b,0
	ld	hl,arptabhi
	add	hl,bc
	ld	a,(hl)
	ld	(ssshi),a
	ld	c,(ix+arpindex)
	ld	a,c
	or	a
	jr	nz,ARP01
	ld	b,0
	ld	hl,(ssslo)
	add	hl,bc
	ld	a,(hl)
	ld	(ix+arpspeed),a
	inc	c
	jp	ARP02
ARP01	ld	a,(ix+arpspeed)
	sub	$10
	ld	(ix+arpspeed),a
	jp	p,ARPNO01

	ld	c,$00
	ld	b,0
	ld	hl,(ssslo)
	add	hl,bc
	ld	a,(hl)
	ld	(ix+arpspeed),a
	ld	c,(ix+arpindex)
ARP02	ld	b,0
	ld	hl,(ssslo)
	add	hl,bc
	ld	a,(hl)
	cp	$ff
	jr	nz,ARP03
	ld	c,$00
	ld	b,0
	ld	hl,(ssslo)
	add	hl,bc
	ld	a,(hl)
	and	$0f
	ld	c,a
	inc	c
	ld	b,0
	ld	hl,(ssslo)
	add	hl,bc
	ld	a,(hl)
ARP03	cp	$fe
	jr	z,NOARP01
	jp	m,NORMA01
	add	a,(ix+realnote)
	ld	(ix+arponoto),a
NORMA01	and	$7f
	ld	(ix+arponoto),a
	inc	c
	ld	a,c
	ld	(ix+arpindex),a
ARPNO01	ld	a,e
	cp	$03
	jp	z,FOR4TOO
	ld	a,(ix+arponoto)
	jp	SETAN01
FOR4TOO
	ld	a,(ix+arponoto)
	ld	(ix+lofrqwrd),a
	ret

SETAN01	ld	c,a
	ld	b,0
	ld	hl,frqtable
	add	hl,bc
	add	hl,bc
	ld	a,(hl)
	ld	(ix+lofrqwrd),a
	inc	hl
	ld	a,(hl)
	ld	(ix+hifrqwrd),a
NOARP01
	ret



; b = reg. no.  , c = reg. value
;
SETVDPREG	LD	A,B
	AND	%00001111
	OR	%10000000
	LD	B,A
	JP	WRITEVDP

; a = col.  , c = ink no (0-31)
;
SETCOLRAM	PUSH	AF

	LD	A,C
	AND	%00011111
	LD	C,A
	LD	B,%11000000
	CALL	WRITEVDP

	POP	AF

	AND	%00111111
	OUT	(VDPDATA),A
	NOP
	NOP
	NOP

	RET

; de = vram adr
;
SETWVRAM	LD	C,E
	LD	A,D
	AND	%00111111
	OR	%01000000
	LD	B,A
	JP	WRITEVDP

SETRVRAM	LD	C,E
	LD	A,D
	AND	%00111111
	LD	B,A
	JP	WRITEVDP


; b/c = 2nd/1st bytes output to vdp chip to select function
;
WRITEVDP	LD	A,C
	OUT	(VDPCOM),A
	JP	+;$+3
+:	LD	A,B
	OUT	(VDPCOM),A
	NOP

	RET

GKEYS	;jp	GKEYS2

	IN	A,(JOYPORT1)
	LD	E,0

	BIT	0,A
	JR	NZ,+ ;$1
	SET	0,E		; up
+:/*$1*/	BIT	3,A
	JR	NZ,+ ;$2
	SET	1,E		; right
+:/*$2*/	BIT	1,A
	JR	NZ,+ ;$3
	SET	2,E		; down
+:/*$3*/	BIT	2,A
	JR	NZ,+ ;$4
	SET	3,E		; left
+:/*$4*/	BIT	4,A
	JR	NZ,+ ;$5
	SET	4,E		; fire1
+:/*$5*/	BIT	5,A
	JR	NZ,+ ;$6
	SET	5,E		; fire2

+:/*$6*/	LD	A,E
	LD	(KEYS),A
	RET

GKEYS2	IN	A,(JOYPORT1)
	LD	E,0

	BIT	6,A
	JR	NZ,+ ;$1
	SET	0,E		; up
+:/*$1*/	BIT	7,A
	JR	NZ,+ ;$2
	SET	2,E		; down
+:/*$2*/	IN	A,(JOYPORT2)
	BIT	1,A
	JR	NZ,+ ;$3
	SET	1,E		; right
+:/*$3*/	BIT	0,A
	JR	NZ,+ ;$4
	SET	3,E		; left
+:/*$4*/	BIT	2,A
	JR	NZ,+ ;$5
	SET	4,E		; fire1
+:/*$5*/	BIT	3,A
	JR	NZ,+ ;$6
	SET	5,E		; fire2

+:/*$6*/	LD	A,E
	LD	(KEYS),A
	RET


SETCOLOURS	LD	BC,32		; copy palet to PALET, for gen. use
	LD	DE,PALET
	LDIR

SETCOL1	LD	HL,PALET
	LD	D,32

-:/*$1*/	LD	A,D
	SUB	32
	NEG
	LD	C,A
	LD	A,(HL)
	CALL	SETCOLRAM

	INC	HL
	DEC	D
	JP	NZ,- ;$1

	RET


VBLANK	PUSH	AF

	XOR	A
	LD	(INTFLAG),A

-:/*$1*/	LD	A,(INTFLAG)
	BIT	7,A
	JP	Z,- ;$1

	POP	AF

	RET



CLS	LD	HL,$0000

CLS1	DI

	LD	DE,$3800+$0000
	CALL	SETWVRAM

	LD	BC,32*25

-:/*$1*/	LD	A,L
	OUT	(VDPDATA),A
	CP	(HL)
	CP	(HL)
	CP	(HL)
	LD	A,H
	OUT	(VDPDATA),A
	CP	(HL)
	DEC	BC
	LD	A,B
	OR	C
	JP	NZ,- ;$1

	EI
	RET


VRAMLDIR	DI
	PUSH	BC
	CALL	SETWVRAM
	POP	BC

-:/*$1*/	LD	A,(HL)
	OUT	(VDPDATA),A
	INC	HL
	DEC	BC
	LD	A,B
	OR	C
	JP	NZ,- ;$1

	EI
	RET


INCNUM	PUSH	IX

	PUSH	HL
	POP	IX
	LD	A,(IX+0)
	LD	H,(IX+1)
	LD	L,(IX+2)
	ADD	HL,DE
	ADC	A,0
	LD	(IX+0),A
	LD	(IX+1),H
	LD	(IX+2),L

	POP	IX
	RET

; entry a  = no. digits
;       de = scr adr
;       hl = number data
;
DNUMBER	DI
	PUSH	AF
	LD	(CHRPOS),DE
	CALL	SETWVRAM
	POP	DE
	LD	A,6
	SUB	D
	LD	D,0
	LD	E,A
	LD	IX,DIGITS
	PUSH	DE

	LD	A,(HL)			; CALCULATE DIGITS !!!
	INC	HL
	LD	D,(HL)
	INC	HL
	LD	L,(HL)
	LD	H,D

	LD	C,1
	LD	DE,34464		; 100,000
	CALL	DNUM1
	LD	C,0
	LD	DE,10000
	CALL	DNUM1
	LD	DE,1000
	CALL	DNUM1
	LD	DE,100
	CALL	DNUM1
	LD	E,10
	CALL	DNUM1

	LD	(IX+0),L

; bugfix: needs a $ff terminator    ; M
    ld d,-1                         ; M
    ld (ix+1),d                     ; M


	POP	DE
	LD	IX,DIGITS
	ADD	IX,DE

-:/*$1*/	LD	A,(IX+0)
	CP	-1
	JP	Z,+ ;$EXIT
	ADD	A,'0'
	CALL	CHAR
	INC	IX
	JP	- ;$1

+: /*$EXIT*/	EI
	RET

DNUM1	LD	B,0
-:/*$2*/	OR	A
	SBC	HL,DE
	SBC	A,C
	JP	C,+ ;$3
	INC	B
	JP	- ;$2
+:/*$3*/	ADD	HL,DE
	ADC	A,C
	LD	(IX+0),B
	INC	IX
	RET


PRS	LD	A,(IX+0)
	CP	-1
	RET	Z
	OR	A
	JP	Z,+ ;$1
	CP	1
	JP	Z,++ ;$2
	CALL	CHAR
	INC	IX
	JP	PRS

+:/*$1*/	INC	IX
	LD	H,(IX+1)
	LD	L,0
	LD	D,L
	SRL	H
	RR	L
	SRL	H
	RR	L
	LD	E,(IX+0)
	SLA	E
	ADD	HL,DE
	LD	DE,$3800
	ADD	HL,DE
	LD	(CHRPOS),HL
	INC	IX
	INC	IX
	JP	PRS

++:/*$2*/	INC	IX
	JP	PRS

CHAR	DI

	LD	HL,CHRCONVTAB
	SUB	32
	LD	E,A
	LD	D,0
	ADD	HL,DE

	LD	DE,(CHRPOS)
	CALL	SETWVRAM

	LD	A,(HL)
	OUT	(VDPDATA),A
	CP	(HL)
	CP	(HL)
	LD	A,0
	OUT	(VDPDATA),A

	LD	HL,(CHRPOS)
	INC	HL
	INC	HL
	LD	(CHRPOS),HL

	EI
	RET


BLACKPALET	/*DEFS*/
.dsb	2*16,BLACK

TEXTPALET	.DB	BLACK,WHITE2,WHITE1,WHITE0,BLACK,YELLOW2,ORANGE,RED2
	.DB	RED1,RED0,GREEN2,GREEN1,GREEN0,CYAN2,BLUE3,WHITE2
TEXTOPALET	.DSb	1*15,BLACK
	.DB	WHITE2

PALET	.db	BLACK,WHITE2,WHITE1,WHITE0,BLACK,BLUE4,BLUE3,BLUE2
	.db	YELLOW2,ORANGE,RED1,GREEN1,GREEN0
	.db	WHITE2,WHITE2,WHITE1

	.db	BLACK,WHITE2,WHITE1,WHITE0,BLACK,BLUE5,BLUE4,BLUE3
	.db	YELLOW2,ORANGE,RED1,GREEN3,GREEN0
	.db	GREEN1,GREEN0,GREEN0



;----------------------------------------------------------------------------------------------------------------------
frqtable
		.dW	$03f5,$03bd,$0387 ;1
		.dW	$0356,$0325,$02f8,$02cd,$02a5,$027f,$025b,$023a,$0219,$01fb,$01de,$01c3 ;2
		.dW	$01aa,$0192,$017b,$0166,$0152,$013f,$012d,$011c,$010c,$00fd,$00ef,$00e1 ;3
		.dW	$00d4,$00c9,$00bd,$00b3,$00a9,$009f,$0096,$008e,$0086,$007e,$0077,$0070 ;4
		.dW	$006a,$0064,$005e,$0059,$0054,$004f,$004a,$0047,$0042,$003e,$003b,$0038 ;5
		.dW	$0035,$0031,$002e,$002c,$0029,$0027,$0025,$0023,$0021,$001f,$001d,$001b ;6
		.dW	$001a,$0019,$0018,$0016,$0015,$0014,$0013,$0012,$0011,$0010,$000f,$000e ;7
;----------------------------------------------------------------------------------------------------------------------


;==============================================================
; Part 1 (1.PDS)
;==============================================================

****************************************
*	MUSIC DATA
****************************************


SFXTAB0	.db	$00,$03,$06,$09,$0b,$0d,$0f,$00
	.db	$15,$19,$1d,$00,$22,$00,$00,$00,$00
	.db	$00,$00,$00,$00,$00,$00,$00,$00
	.db	$00,$00,$00,$00,$00,$00,$00,$00
	.db	$00,$00,$00,$00,$00,$00,$00,$00
	.db	$00,$00,$00,$00,$00,$00,$00
	.db	$00,$00

SFXTAB1	.db	$00,$04,$07,$0a,$0c,$0e,$10,$00
	.db	$16,$1a,$1e,$00,$23,$00,$00,$00,$00
	.db	$00,$00,$00,$00,$00,$00,$00,$00
	.db	$00,$00,$00,$00,$00,$00,$00,$00
	.db	$00,$00,$00,$00,$00,$00,$00,$00
	.db	$00,$00,$00,$00,$00,$00,$00
	.db	$00,$00

SFXTAB2	.db	$01,$05,$08,$00,$00,$00,$00,$13
	.db	$17,$1b,$1f,$21,$24,$26,$28,$00,$00
	.db	$2c,$00,$00,$30,$00,$32,$34,$35
	.db	$37,$38,$39,$3b,$3d,$00,$00,$40
	.db	$42,$44,$00,$00,$48,$49,$4a,$4b
	.db	$00,$00,$00,$00,$51,$52,$53
	.db	$00,$00

SFXTAB3	.db	$02,$00,$00,$00,$00,$00,$00,$14
	.db	$18,$1c,$20,$00,$25,$27,$29,$2a,$2b
	.db	$2d,$2e,$2f,$00,$31,$33,$00,$36
	.db	$00,$00,$3a,$3c,$00,$3e,$3f,$41
	.db	$43,$45,$46,$47,$00,$00,$00,$4c
	.db	$4d,$4e,$4f,$50,$00,$00,$00
	.db	$54,$55
				; lda ldx
AUDTABLE	.dw	clearaud		; $00 $xx
	.dw	AT_DRUMS2		; $01 $02
	.dw	AT_DRUMS3		; $02 $03
	.dw	AT_TITLE0		;	$03 $00
	.dw	AT_TITLE1		;	$04 $01
	.dw	AT_TITLE2		;	$05 $02
	.dw	INTRO0		;	$06	$00
	.dw	INTRO1		;	$07	$01
	.dw	INTRO2		;	$08	$02
	.dw	LEVELSAV0		;	$09	$00
	.dw	LEVELSAV1		;	$0a	$01
	.dw	LEVELRIV0		;	$0b	$00
	.dw	LEVELRIV1		;	$0c	$01
	.dw	LEVELJUN0		;	$0d	$00
	.dw	LEVELJUN1		;	$0e	$01
	.dw	LEVELMIL0		;	$0f $00
	.dw	LEVELMIL1		;	$10 $01
	.dw	KNOCKJIN2		;	$11	$00 ;left/leave out!
	.dw	KNOCKJIN2		;	$12	$00	;left/leave out!
	.dw	KNOCKJIN2		;	$13	$02
	.dw	KNOCKJIN3		;	$14	$03
	.dw	GAMEOVER0		;	$15	$00
	.dw	GAMEOVER1		;	$16	$01
	.dw	GAMEOVER2		;	$17	$02
	.dw	GAMEOVER3		;	$18	$03
	.dw	WONGAME0		;	$19	$00
	.dw	WONGAME1		;	$1a	$01
	.dw	WONGAME2		;	$1b	$02
	.dw	WONGAME3		;	$1c	$03
	.dw	MAPJINGL0		;	$1d	$00
	.dw	MAPJINGL1		;	$1e	$01
	.dw	MAPJINGL2		;	$1f	$02
	.dw	MAPJINGL3		;	$20	$03
	.dw	UHOHBOSS0		;	$21	$00
	.dw	ENDOFLEV0		;	$22	$00
	.dw	ENDOFLEV1		;	$23	$01
	.dw	ENDOFLEV2		;	$24	$02
	.dw	ENDOFLEV3		;	$25	$03

	.dw	PUNCH2		;	$26,$02
	.dw	PUNCH3		;	$27,$03
	.dw	HEADBUTT2		;	$28,$02
	.dw	HEADBUTT3		;	$29,$03
	.dw	JUMPKICK3		;	$2a,$03
	.dw	BACKKICK3		;	$2b,$03
	.dw	JUMPLAND2		;	$2c,$02
	.dw	JUMPLAND3		;	$2d,$03
	.dw	THROWHEA3		;	$2e,$03
	.dw	CHAINSWI3		;	$2f,$03
	.dw	BIGGUNFI2		;	$30,$02
	.dw	SWIPEOBJ3		;	$31,$03
	.dw	GROUNDSH2		;	$32,$02
	.dw	GROUNDSH3		;	$33,$03
	.dw	ENERGYLO2		;	$34,$02
	.dw	BEINGHIT2		;	$35,$02
	.dw	BEINGHIT3		;	$36,$03
	.dw	STUNNED2		;	$37,$02
	.dw	PICKUP2		;	$38,$02
	.dw	BOSPUNCH2		;	$39,$02
	.dw	BOSPUNCH3		;	$3a,$03
	.dw	BOSHIT2		;	$3b,$02
	.dw	BOSHIT3		;	$3c,$03
	.dw	BOSSTUNN2		;	$3d,$02
	.dw	HELICOPT3		;	$3e,$03
	.dw	HELIROCK2		;	$3f,$03
	.dw	EXPLO_1_2		;	$40,$02
	.dw	EXPLO_1_3		;	$41,$03
	.dw	EXPLO_2_2		;	$42,$02
	.dw	EXPLO_2_3		;	$43,$03
	.dw	EXPLO_3_2		;	$44,$02
	.dw	EXPLO_3_3		;	$45,$03
	.dw	PARASWOP3		;	$46,$03
	.dw	CRKBRIDG3		;	$47,$03
	.dw	DOGBARK2		;	$48,$02
	.dw	DOGGRRR2		;	$49,$02
	.dw	DOGHIT2		;	$4a,$02
	.dw	BULLET2		;	$4b,$02
	.dw	BULLET3		;	$4c,$03
	.dw	HELIFLY3		;	$4d,$03
	.dw	HELILAND3		;	$4e,$03
	.dw	HELITAKE3		;	$4f,$03
	.dw	SPLASH3		;	$50,$03
	.dw	MISC_A_2		;	$51,$02
	.dw	MISC_B_2		;	$52,$02
	.dw	MISC_C_2		;	$53,$02
	.dw	MISC_D_3		;	$54,$03
	.dw	MISC_E_3		;	$55,$03

seqtabes	.db	$00,$00		; $00
	.db	$02,$02 		; $01
	.db	$02,$02		; $02
	.db	$02,$02		; $03
	.db	$02,$02		; $04
	.db	$02,$02		; $05
	.db	$02,$02		; $06
	.db	$02,$02		; $07
	.db	$02,$02		; $08
	.db	$01,$01		; $09
	.db	$01,$01		; $0a
	.db	$01,$01		; $0b
	.db	$01,$01		; $0c
	.db	$02,$02		; $0d
	.db	$02,$02		; $0e
	.db	$02,$02		; $0f
	.db	$02,$02		; $10
	.db	$02,$01		; $11
	.db	$02,$01		; $12
	.db	$02,$02		; $13
	.db	$02,$02		; $14
	.db	$02,$02		; $15
	.db	$02,$02		; $16
	.db	$02,$02		; $17
	.db	$02,$02		; $18
	.db	$02,$02		; $19
	.db	$02,$02		; $1a
	.db	$02,$02		; $1b
	.db	$02,$02		; $1c
	.db	$02,$02		; $1d
	.db	$02,$02		; $1e
	.db	$02,$02		; $1f
	.db	$02,$02		; $20
	.db	$02,$02		; $21
	.db	$04,$04		; $22
	.db	$04,$04		; $23
	.db	$04,$04		; $24
	.db	$04,$04		; $25
	.db	$02,$02		; $26
	.db	$02,$02		; $27
	.db	$02,$02		; $28
	.db	$02,$02		; $29
	.db	$02,$02		; $2a
	.db	$02,$02		; $2b
	.db	$02,$02		; $2c
	.db	$02,$02		; $2d
	.db	$07,$07		; $2e
	.db	$07,$07		; $2f
	.db	$02,$02		; $30
	.db	$05,$05		; $31
	.db	$02,$02		; $32
	.db	$02,$02		; $33
	.db	$02,$02		; $34
	.db	$02,$02		; $35
	.db	$02,$02		; $36
	.db	$02,$02		; $37
	.db	$02,$02		; $38
	.db	$02,$02		; $39
	.db	$06,$06		; $3a
	.db	$02,$02		; $3b
	.db	$02,$02		; $3c
	.db	$02,$02		; $3d
	.db	$7f,$7f		;	$3e
	.db	$02,$02		;	$3f
	.db	$02,$02		;	$40
	.db	$02,$02		;	$41
	.db	$02,$02		;	$42
	.db	$02,$02		;	$43
	.db	$02,$02		;	$44
	.db	$02,$02		;	$45
	.db	$02,$01		;	$46
	.db	$02,$02		;	$47
	.db	$02,$02		;	$48
	.db	$02,$02		;	$49
	.db	$02,$02		;	$4a
	.db	$02,$02		;	$4b
	.db	$02,$02		;	$4c
	.db	$02,$02		;	$4d
	.db	$02,$02		;	$4e
	.db	$02,$02		;	$4f
	.db	$02,$02		;	$50
	.db	$02,$02		;	$51
	.db	$02,$02		;	$52
	.db	$02,$02		;	$53
	.db	$02,$02		;	$54
	.db	$02,$02		;	$55
stptablo
	.db	<s00,<s01,<s02,<s03,<s04,<s05,<s06,<s07,<s08,<s09,<s0a,<s0b,<s0c,<s0d,<s0e,<s0f
	.db	<s10,<s11,<s12,<s13,<s14,<s15,<s16,<s17,<s18,<s19,<s1a,<s1b,<s1c,<s1d,<s1e,<s1f
	.db	<s20,<s21,<s22,<s23,<s24,<s25,<s26,<s27,<s28,<s29,<s2a,<s2b,<s2c,<s2d,<s2e,<s2f
	.db	<s30,<s31,<s32,<s33,<s34,<s35,<s36,<s37,<s38,<s39,<s3a,<s3b,<s3c,<s3d,<s3e,<s3f
	.db	<s40,<s41,<s42,<s43,<s44,<s45,<s46,<s47,<s48,<s49,<s4a,<s4b,<s4c,<s4d,<s4e,<s4f
	.db	<s50,<s51,<s52,<s53,<s54,<s55,<s56,<s57,<s58,<s59,<s5a,<s5b,<s5c,<s5d,<s5e,<s5f
	.db	<s60,<s61,<s62,<s63,<s64,<s65,<s66,<s67,<s68,<s69,<s6a,<s6b,<s6c,<s6d,<s6e,<s6f
	.db	<s70,<s71,<s72,<s73,<s74,<s75,<s76,<s77,<s78,<s79,<s7a,<s7b,<s7c,<s7d,<s7e,<s7f

stptabhi	.db	>s00,>s01,>s02,>s03,>s04,>s05,>s06,>s07,>s08,>s09,>s0a,>s0b,>s0c,>s0d,>s0e,>s0f
	.db	>s10,>s11,>s12,>s13,>s14,>s15,>s16,>s17,>s18,>s19,>s1a,>s1b,>s1c,>s1d,>s1e,>s1f
	.db	>s20,>s21,>s22,>s23,>s24,>s25,>s26,>s27,>s28,>s29,>s2a,>s2b,>s2c,>s2d,>s2e,>s2f
	.db	>s30,>s31,>s32,>s33,>s34,>s35,>s36,>s37,>s38,>s39,>s3a,>s3b,>s3c,>s3d,>s3e,>s3f
	.db	>s40,>s41,>s42,>s43,>s44,>s45,>s46,>s47,>s48,>s49,>s4a,>s4b,>s4c,>s4d,>s4e,>s4f
	.db	>s50,>s51,>s52,>s53,>s54,>s55,>s56,>s57,>s58,>s59,>s5a,>s5b,>s5c,>s5d,>s5e,>s5f
	.db	>s60,>s61,>s62,>s63,>s64,>s65,>s66,>s67,>s68,>s69,>s6a,>s6b,>s6c,>s6d,>s6e,>s6f
	.db	>s70,>s71,>s72,>s73,>s74,>s75,>s76,>s77,>s78,>s79,>s7a,>s7b,>s7c,>s7d,>s7e,>s7f

amptabl	.db	<am00,<am01,<am02,<am03,<am04,<am05,<am06,<am07
	.db	<am08,<am09,<am0a,<am0b,<am0c,<am0d,<am0e,<am0f
	.db	<am10,<am11,<am12,<am13,<am14,<am15,<am16,<am17
	.db	<am18

amptabh	.db	>am00,>am01,>am02,>am03,>am04,>am05,>am06,>am07
	.db	>am08,>am09,>am0a,>am0b,>am0c,>am0d,>am0e,>am0f
	.db	>am10,>am11,>am12,>am13,>am14,>am15,>am16,>am17
	.db	>am18

vibtabl	.db	<v01,<v02,<v03,<v04,<v05,<v06,<v07,<v08
vibtabh	.db	>v01,>v02,>v03,>v04,>v05,>v06,>v07,>v08

arptablo 	.db 	<a00,<a01,<a02,<a03,<a04,<a05,<a06,<a07
	.db	<a08,<a09,<a0a,<a0b,<a0c,<a0d,<a0e,<a0f
	.db 	<a10,<a11,<a12,<a13,<a14,<a15,<a16,<a17
	.db	<a18,<a19,<a1a,<a1b,<a1c,<a1d,<a1e,<a1f

arptabhi	.db 	>a00,>a01,>a02,>a03,>a04,>a05,>a06,>a07
	.db	>a08,>a09,>a0a,>a0b,>a0c,>a0d,>a0e,>a0f
	.db 	>a10,>a11,>a12,>a13,>a14,>a15,>a16,>a17
	.db	>a18,>a19,>a1a,>a1b,>a1c,>a1d,>a1e,>a1f
;-----------------------------------------------------------------------------
am00
	.db	15,14,12,10,$fe
am01
	.db	12,10,9,8,$fe
am02
	.db	10,8,7,6,$fe
am03
	.db	8,6,5,4,$fe
am04
	.db	6,4,3,2,$fe
am05
	.db	4,3,2,1,$fe
am06
	.db	2,1,$fe
am07
	.db	15,15,15,15,14,15,14,15,14,14,14,14,13,14,13,14,13,13,13,13,12,13,12,13,12,12,12,12,11,12,11,12
	.db	11,11,11,11,10,11,10,11,10,10,10,10,9,10,9,10,9,9,9,9,8,9,8,9,8,8,8,8,7,8,7,8,7,7,7,7
	.db	6,7,6,7,6,6,6,6,5,6,5,6,5,5,5,5,4,5,4,5,4,4,4,4,3,4,3,4,3,3,3,3,2,3,2,3,2,2,2,2,1,2,1,2,1
	.db	1,1,1,0,1,0,1,0
	.db	$fe
am08
	.db	12,9,6,3,1,$fe
am09
	.db	15,13,11,9,$fe
am0a
	.db	15,10,8,7,6,5,4,3,2,1,0,$fe
am0b
	.db	15,13,12,10,9,8,8,7,7,6,6,6,5,5,5,4,5,4,4,4,3,4,3,3,3,2,3,2,3,2,2,2,2,1,2,1,2,1,1,1,1,0,1,0,1,0,$fe
am0c
	.db	15,13,11,10,9,8,8,7,7,6,6,5,5,4,4,3,3,3,2,2,2,1,1,1,0,$fe
am0d
	.db	12,9,6,5,4,3,2,1,$fe
am0e
	.db	2,5,8,10,12,14,15,$fe
am0f
	.db	0,1,2,2,$10,3,4,4,5,$10,5,6,5,6,$10,6,6,6,7,$10,6,7,7,7,$10,7,8,7,8,$10,8,8,8,8,$10,8,9,8,9
	.db	$10,8,9,9,9,$10,9,9,9,10,$10,9,10,9,10,$10
	.db	10,10,10,10,$10,10,10,9,10,$10,9,10,9,9,$10,9,9,8,9,$10,8,9,8,8
	.db	$10,8,8,7,8,$10,7,8,7,7,$10,7,7,6,7,$10,6,7,6,6,$10,6,6,5,6,$10
	.db	5,6,5,5,$fe
am10
	.db	8,$10,12,$10,15,$10
	.db	12,$10,$10,8,$10,$10,$10,6,$10,$10,$10
	.db	4,$10,$10,$10,2,$10
	.db	$fe
am11
	.db	15,0,15,0,12,0,12,0,8,0,10,0,$10,$fe
am12
am13
am14
am15
am16
am17
am18
;-----------------------------------------------------------------------------
v01
	.db	$02,$01,$01,$fe,$ff,$ff
	.db	$fe,$ff,$ff,$02,$01,$01
	.db	$80
v02
	.db	$02,$02,$fe,$fe
	.db	$fe,$fe,$02,$02
	.db	$80
v03
	.db	$03,$02,$02,$fd,$fe,$fe
	.db	$fd,$fe,$fe,$03,$02,$02
	.db	$80
v04
	.db	$02,$01,$01,$fe,$ff,$ff
	.db	$fe,$ff,$ff,$02,$01,$01
	.db	$80
v05
v06
v07
v08
;-----------------------------------------------------------------------------
a00	.db	$03,7,3,0,7,7,3,3,0,0,$ff
a01	.db	$03,7,4,0,7,7,4,4,0,0,$ff
a02	.db	$03,8,5,0,8,8,5,5,0,0,$ff
a03	.db    $03,9,5,0,9,9,5,5,0,0,$ff
a04	.db	$03,8,3,0,8,8,3,3,0,0,$ff
a05	.db	$03,9,4,0,9,9,4,4,0,0,$ff
a06	.db	$00,$00,$fe
a07	.db	$00,$88,$84,$80,$00,$fe
a08	.db	$00,$90,$8e,$8c,$00,$fe
a09	.db	$90,$8c,$89,$87,$86,$85,$84,$83,$82,$82,$81,$81,$80,$fe
a0a	.db	$00,12,0,$fe
a0b	.db	$03,10,5,0,10,10,5,5,0,0,$ff
a0c	.db	$03,7,5,0,7,7,5,5,0,0,$ff
a0d	.db	$20,12,0,$fe
a0e	.db	$04,8,5,3,2,1,0,$ff
a0f	.db	$00,0,12,12,12,0,$fe
a10	.db	$30,24,12,0,$fe
a11	.db	$00,0,0,0,0,1,1,1,1,$ff
a12	.db	$30,7,0,$ff
a13	.db	$10,5,0,$ff
a14	.db	$10,6,0,$ff
a15    	.db	$10,8,0,$ff
a16	.db	$03,12,7,0,12,12,7,7,0,0,$ff
a17   	.db	$00,0,1,$ff
a18	.db	$00,12,12,0,12,8,8,12,8,4,4,8,4,0,0,4,0
	.db	15,15,0,15,10,10,15,10,5,5,10,5,0,0,5,0,$ff
a19	.db	$00,10,7,8,5,7,4,6,3,6,3,5,2,5,2,4,1,4,1,3,0,3,0,2,0,2,0,1,0,$fe
a1a	.db	$00,5,3,4,2,3,1,2,0,1,0,$fe
a1b	.db	$04,14,10,12,8,10,6,9,5,8,4,7,3,6,2,5,1,4,0,$ff
a1c	.db	$00,10,7,9,6,8,5,7,4,7,4,6,3,6,3,5,2,5,2,4,1,4,1,3,0,3,0,$ff
a1d	.db	$00,2,0,6,4,10,8,9,7,8,6,6,4,5,3,4,2,3,1,2,0,$fe
a1e	.db	$00,0,0,10,0,7,7,0,7,5,5,7,5,10,10,5,10,$ff
a1f	.db	$00,2,1,0,1,2,$ff
;-----------------------------------------------------------------------------
soundfix	;           ---/---,arp/vibtab,vibdel/---,amptab



;Volume15
		.db	$00,$41,$40,$00 ;c0
;volume12
		.db	$00,$41,$40,$01	;c1
;volume10
		.db	$00,$41,$40,$02	;c2
;volume8
		.db	$00,$41,$40,$03	;c3
;volume6
		.db	$00,$41,$40,$04	;c4
;volume4
		.db	$00,$41,$40,$05	;c5
;volume2
		.db	$00,$41,$40,$06	;c6
;LongDown
		.db	$00,$40,$00,$07	;c7
;NoiseShort
		.db	$00,$41,$40,$08	;c8
;NoiseNrm
		.db	$00,$41,$40,$09	;c9
;NoiseHard
		.db	$00,$41,$40,$0a	;ca
;BoldDelay
		.db	$00,$41,$40,$0b	;cb
;BASSBVIBO
		.db	$00,$43,$40,$00	;cc
;Volume15-VIB
		.db	$00,$02,$10,$00 ;cd
;FadeSmooth
		.db	$00,$40,$00,$0c	;ce
;FadeSmoothSoft
		.db	$00,$40,$00,$0d	;cf
;FadeUpFast
		.db	$00,$40,$00,$0e	;d0
;CHOPPER
		.db	$00,$40,$00,$0f	;d1
;BoldDelay2
		.db	$00,$40,$00,$0b	;d2
;BRIDGYCRACK
		.db	$00,$00,$00,$10	;d3
;WROOOF
		.db	$00,$00,$00,$11	;d4
;----------------------------------------------------------------------------
PUNCH2	.db	$86,$30,$fe
PUNCH3	.db	$80,$31,$fe

s30	.db	$ce,$85,$79,$00
	.db	$ff
s31	.db	$c9,$83,$66,$04
	.db	$ff

HEADBUTT2	.db	$80,$30,$fe
HEADBUTT3	.db 	$81,$31,$fe

JUMPKICK3	.db	$80,$32,$fe

s32	.db	$d0,$83,$66,$05,$ca,$83,$04
	.db	$ff

BACKKICK3	.db	$80,$33,$fe

s33	.db	$d0,$83,$66,$06,$ca,$83,$04
	.db	$ff

JUMPLAND2	.db	$80,$34,$fe
JUMPLAND3	.db	$80,$35,$fe

s34	.db	$c9,$83,$7a,$00,$ff
s35	.db	$c8,$83,$66,$06,$ff

THROWHEA3	.db	$80,$36,$fe

s36	.db	$d0,$81,$66,$05,$cb,$84,$66,$05
	.db	$ff

CHAINSWI3	.db	$80,$37,$ff,$00

s37	.db	$d0,$81,$66,$04,$ca,$81,$04
	.db	$ff

BIGGUNFI2	.db	$80,$38,$fe

s38	.db	$ce,$85,$7b,$00
	.db	$ff

SWIPEOBJ3	.db	$81,$37,$00,$fe

GROUNDSH2	.db	$80,$39,$fe
GROUNDSH3	.db	$82,$3a,$fe

s39	.db	$c7,$b0,$7c,$00
	.db	$ff
s3a	.db	$c7,$b0,$66,$04
	.db	$ff

ENERGYLO2	.db	$80,$3b,$fe

s3b	.db	$c0,$82,$6d,$31,$c2,$c4,$c6
	.db	$ff

BEINGHIT2	.db	$88,$3c,$fe
BEINGHIT3	.db	$80,$3d,$fe

s3c	.db	$ce,$86,$7d,$00,$ff
s3d	.db	$ce,$82,$66,$05,$ff

STUNNED2	.db	$80,$3e,$fe

s3e	.db	$ce,$81,$7d,$04,$03,$04,$03,$02,$01,$02,$01,$84,$00
	.db	$ff

PICKUP2	.db	$80,$3f,$fe

s3f	.db	$cb,$8f,$7e,$28,$ff

BOSPUNCH2	.db	$80,$40,$fe
BOSPUNCH3	.db	$81,$3d,$fe

s40	.db	$ce,$88,$7c,$00
	.db	$ff

BOSHIT2	.db	$80,$41,$fe
BOSHIT3	.db	$80,$42,$fe

s41	.db	$ce,$81,$7d,$08,$05,$03,$01,$84,$00,$ff
s42	.db	$ce,$8f,$71,$05
	.db	$ff

BOSSTUNN2	.db	$80,$43,$fe

s43	.db	$ce,$81,$7d,$01,$04,$08,$0c,$09,$07,$05,$03,$02,$82,$01,$ff

HELICOPT3	.db	$80,$44,$ff,$00

s44	.db	$d1,$bf,$7f,$04
	.db	$ff

HELIROCK2	.db	$80,$45,$fe

s45	.db	$d0,$81,$66,$06,$05,$83,$04,$d2,$8c,$04
	.db	$ff

EXPLO_1_2	.db	$80,$46,$fe
EXPLO_1_3	.db	$80,$47,$fe

s46	.db	$cb,$90,$7b,$00
	.db	$ff

s47	.db	$d2,$90,$66,$05
	.db	$ff

EXPLO_2_2	.db	$80,$48
	.db	$fe
EXPLO_2_3	.db	$81,$3a
	.db	$fe
s48
	.db	$cb,$81,$00,$02,$04,$06,$08,$0a,$08,$06,$90,$7c,$04
	.db	$ff

EXPLO_3_2	.db	$80,$49
	.db	$fe

s49	.db	$cb,$81,$7c,$00,$08,$06,$04,$02,$01,$90,$00
	.db	$ff

EXPLO_3_3	.db	$80,$4a
	.db	$fe
s4a
	.db	$d2,$81,$66,$06,$05,$04,$05,$90,$06
	.db	$ff

PARASWOP3	.db	$80,$4b,$fe

s4b	.db	$c1,$81,$66,$06,$05,$04,$05,$83,$06
	.db	$ff

CRKBRIDG3	.db	$80,$4c,$fe

s4c	.db	$d3,$8c,$06
	.db	$ff

DOGBARK2	.db	$80,$4d,$fe

s4d	.db	$d4,$89,$fd,$1f,$0c,$05
	.db	$ff

DOGGRRR2	.db	$80,$4e,$fe

s4e	.db	$d4,$89,$fd,$05,$03,$00
	.db	$ff

DOGHIT2	.db	$80,$4f,$fe

s4f	.db	$d4,$89,$fd,$01,$2c,$27
	.db	$ff

BULLET2	.db	$80,$50,$fe
BULLET3	.db	$80,$51,$fe

s50
	.db	$cb,$84,$79,$00
	.db	$ff
s51
	.db	$ca,$81,$66,$04,$05,$83,$06
	.db	$ff

HELIFLY3	.db	$80,$52,$ff,$00
	.db	$ff
HELILAND3	.db	$80,$53
	.db	$fe
HELITAKE3	.db	$80,$54,$52,$ff,$02

s52
	.db	$c2,$81,$66,$06,$e1
	.db	$ff
s53
	.db	$c2,$81,$66,$06,$e2
	.db	$c2,$81,$66,$06,$e2
	.db	$c2,$81,$66,$06,$e3
	.db	$c2,$81,$66,$06,$e3
	.db	$c2,$81,$66,$06,$e4
	.db	$c2,$81,$66,$06,$e4
	.db	$c2,$81,$66,$06,$e5
	.db	$c2,$81,$66,$06,$e6
	.db	$c2,$81,$66,$06,$e7
	.db	$c2,$81,$66,$06,$e8
	.db	$c2,$81,$66,$06,$e9
	.db	$c2,$81,$66,$06,$ea
	.db	$c2,$81,$66,$06,$eb
	.db	$c2,$81,$66,$06,$ec
	.db	$c2,$81,$66,$06,$ed
	.db	$c2,$81,$66,$06,$f0
	.db	$c2,$81,$66,$06,$f4
	.db	$c2,$81,$66,$06,$f8
	.db	$c2,$81,$66,$06,$e1
	.db	$ff
s54
	.db	$c2,$81,$66,$06,$ec
	.db	$81,6,$ea
	.db	$81,6,$e8
	.db	$81,6,$e6
	.db	$81,6,$e5
	.db	$81,6,$e4
	.db	$81,6,$e4
	.db	$81,6,$e3
	.db	$81,6,$e3
	.db	$81,6,$e2
	.db	$81,6,$e2
	.db	$81,6,$e2
	.db	$81,6,$e2
	.db	$ff

SPLASH3	.db	$80,$3a,$fe



MISC_A_2
	.db	$80,$55,$fe
MISC_B_2
	.db	$80,$56,$fe
MISC_C_2
	.db	$80,$57,$fe
MISC_D_3
	.db	$80,$58,$fe
MISC_E_3
	.db	$80,$59,$fe

s55	.db	$ca,$87,$6e,$15
	.db	$ff

s56	.db	$ca,$85,$7d,$0c
	.db	$ff
s57
	.db	$c3,$81,$66,$24,$28,$29,$25,$26,$2a,$2b,$27,$28,$2c,$2b
	.db	$2a,$27,$29,$26,$28,$25,$27,$24,$e1
	.db	$ff
s58
	.db	$c7,$b0,$77,$04
	.db	$ff
s59
	.db	$c0,$81,$66,$04,$05,$06,$05,$04,$c1,$05,$c2,$06
	.db	$c3,$04,$c4,$05,$c5,$06,$e1
	.db	$ff
s5a
s5b
s5c
s5d
s5e
s5f
s60
s61
s62
s63
s64
s65
s66
s67
s68
s69
s6a
s6b
s6c
s6d
s6e
s6f
s70
s71
s72
s73
s74
s75
s76
s77
s78
s79
s7a
s7b
s7c
s7d
s7e
s7f



;==============================================================
; Part 2 (2.PDS)
;==============================================================


AT_DRUMS2		.db	$80,$01,$ff,$00
AT_DRUMS3		.db	$80,$02,$ff,$00

s01
		.db	$ca,$81,$69,0,0,$82,0
		.db	$ca,$82,0,0
		.db	$ca,$84,0
		.db	$ca,$82,0,0,0,0
		.db	$ca,$84,0
		.db	$ca,$81,0,0,$82,0
		.db	$ca,$82,0,0
		.db	$ca,$81,0,0,$82,0
		.db	$ca,$81,0,0,$82,0
		.db	$ca,$82,0,0
		.db	$ca,$81,0,0,$82,0
		.db	$ca,$81,0,0,$8e,0
		.db	$ff
s02
		.db	$ca,$81,$66,4,4,$82,4
		.db	$ca,$82,4,4
		.db	$ca,$84,4
		.db	$ca,$82,4,4,4,4
		.db	$ca,$84,4
		.db	$ca,$81,4,4,$82,4
		.db	$ca,$82,4,4
		.db	$ca,$81,4,4,$82,4
		.db	$ca,$81,4,4,$82,4
		.db	$ca,$82,4,4
		.db	$ca,$81,4,4,$82,4
		.db	$ca,$81,4,4,$8e,4
		.db	$ff

AT_TITLE0		.db	$80,$03,$03
		.db	$87,$06,$06
		.db	$ff,$00
AT_TITLE1
		.db	$80,$04,$04
		.db	$8c,$06,$06
		.db	$ff,$00
AT_TITLE2
		.db	$80,$05,$05,$05,$05
		.db	$85,7,8,7,8,7,8,$81,7,$83,8
		.db	$85,7,8,7,8,7,8,$81,7,$83,8
		.db	$ff,$00

s03
	.db	$c0,$84,$6a,$18,$82,$18,$18,$84,$18,$18,$1f,$18,$1f,$18
	.db	$c0,$86,$1d,$82,$1c,$1a,$86,$18,$90,$1a
	.db	$c0,$84,$18,$82,$18,$18,$84,$18,$18,$1f,$18,$1f,$24
	.db	$c0,$86,$22,$82,$21,$1f,$86,$1d,$88,$1f
	.db	$c1,$82,$66,$23,$26,$84,$2b
	.db	$ff
s04
	.db	$c0
	.db	$84,$64,$10
	.db	$82,$64,$10
	.db	$82,$64,$10
	.db	$84,$64,$10
	.db	$84,$64,$10
	.db	$84,$61,$18
	.db	$84,$64,$10
	.db	$84,$61,$18
	.db	$84,$64,$10
	.db	$86,$61,$16
	.db	$82,$6b,$11
	.db	$82,$63,$11
	.db	$86,$6c,$11
	.db	$90,$61,$13
	.db	$84,$64,$10
	.db	$82,$64,$10
	.db	$82,$64,$10
	.db	$84,$64,$10
	.db	$84,$64,$10
	.db	$84,$61,$18
	.db	$84,$64,$10
	.db	$84,$61,$18
	.db	$84,$64,$1c
	.db	$86,$64,$1a
	.db	$82,$60,$1a
	.db	$82,$65,$16
	.db	$86,$61,$16
	.db	$90,$64,$17
	.db	$ff
s05
	.db	$c0,$84,$67,$00
	.db	$c0,$82,$66,$00
	.db	$c0,$82,$66,$00
	.db	$c0,$84,$68,$00
	.db	$c0,$84,$66,$00
	.db	$c0,$82,$67,$00
	.db	$c0,$82,$66,$00
	.db	$c0,$84,$66,$00
	.db	$c0,$84,$68,$00
	.db	$c0,$84,$66,$00
	.db	$c0,$84,$67,$0a
	.db	$c0,$82,$66,$0a
	.db	$c0,$82,$66,$0a
	.db	$c0,$84,$68,$0a
	.db	$c0,$84,$66,$0a
	.db	$c0,$82,$67,$07
	.db	$c0,$82,$66,$07
	.db	$c0,$84,$66,$07
	.db	$c0,$84,$68,$07
	.db	$c0,$84,$66,$07
	.db	$ff
s06
	.db	$c0,$84,$6d,$11
	.db	$c0,$84,$11
	.db	$c0,$84,$0f
	.db	$c0,$84,$11,$c4,$0f
	.db	$c0,$84,$0f,$c4,$11
	.db	$c0,$84,$11,$c4,$0f
	.db	$c0,$84,$0c
	.db	$c0,$84,$0f
	.db	$c0,$84,$11
	.db	$c0,$84,$14
	.db	$c0,$84,$13
	.db	$c0,$84,$0f
	.db	$c0,$84,$0c
	.db	$c0,$84,$11
	.db	$c0,$84,$11
	.db	$c0,$84,$0f
	.db	$c0,$84,$11,$c4,$0f
	.db	$c0,$84,$0c,$c4,$11
	.db	$c0,$94,$0d,$90,$0f
	.db	$ff
s07
	.db	$c0,$84,$68,$00
	.db	$c0,$82,$66,$00,$00
	.db	$c0,$84,$68,$00
	.db	$c0,$82,$66,$00,$00
	.db	$ff
s08
	.db	$c0,$82,$68,$00,$66,$00
	.db	$c0,$84,$68
	.db	$c0,$84,$68
	.db	$c0,$82,$66,$00,$00
	.db	$ff

INTRO0
	.db	$80,$09,$09,$83,$09,$09
	.db	$ff,$00
INTRO1
	.db	$80,$0a,$0c,$83,$0c,$0c
	.db	$ff,$00
INTRO2
	.db	$80,$0b,$0b,$83,$0b,$0b
	.db	$ff,$00

s09	.db	$cb
	.db	$94,$67,$00
	.db	$8c,$00
	.db	$94,$00
	.db	$8c,$00
	.db	$94,$00
	.db	$8c,$00
	.db	$94,$00
	.db	$84,$03
	.db	$84,$05
	.db	$84,$07
	.db	$94,$00
	.db	$8c,$00
	.db	$94,$00
	.db	$8c,$00
	.db	$94,$00
	.db	$8c,$00
	.db	$88,$00
	.db	$88,$03
	.db	$88,$05
	.db	$88,$07
	.db	$ff
s0a
	.db	$cb,$84,$6a
	.db	$07,$c2,$07,$07,$07,$07,$cb,$07,$c2,$07,$07
	.db	$cb,$0c,$c2,$0c,$0c,$0c,$0c,$cb,$0c,$c2,$0c,$0c
	.db	$cb,$0c,$c2,$0c,$0c,$0c,$0c,$cb,$0c,$c2,$0c,$0c
	.db	$cb,$0a,$c2,$0a,$0a,$0a,$0a,$cb,$0a,$c2,$0a,$0a
	.db	$cb,$07,$c2,$07,$07,$07,$07,$cb,$07,$c2,$07,$07
	.db	$cb,$0c,$c2,$0c,$0c,$0c,$0c,$cb,$0c,$c2,$0c,$0c
	.db	$cb,$0c,$c2,$0c,$0c,$0c,$0c,$cb,$0c,$c2,$0c,$0c
	.db	$cb,$0f,$c2,$0f,$0f,$0f,$cb,$0e,$c2,$0e,$0e,$0e
	.db	$ff
s0b
	.db	$cb,$84,$6a
	.db	$0c,$c2,$0c,$0c,$0c,$0c,$cb,$0c,$c2,$0c,$0c
	.db	$cb,$13,$c2,$13,$13,$13,$13,$cb,$13,$c2,$13,$13
	.db	$cb,$14,$c2,$14,$14,$14,$14,$cb,$14,$c2,$14,$14
	.db	$cb,$11,$c2,$11,$11,$11,$11,$cb,$11,$c2,$11,$11
	.db	$cb,$0c,$c2,$0c,$0c,$0c,$0c,$cb,$0c,$c2,$0c,$0c
	.db	$cb,$13,$c2,$13,$13,$13,$13,$cb,$13,$c2,$13,$13
	.db	$cb,$14,$c2,$14,$14,$14,$14,$cb,$14,$c2,$14,$14
	.db	$cb,$16,$c2,$16,$16,$16,$cb,$16,$c2,$16,$16,$16
	.db	$ff
s0c
	.db	$cb,$84,$65
	.db	$03,$c2,$03,$03,$03,$03,$cb,$03,$c2,$03,$03
	.db	$cb,$60,$0c,$c2,$0c,$0c,$0c,$0c,$cb,$0c,$c2,$0c,$0c
	.db	$cb,$64,$0c,$c2,$0c,$0c,$0c,$0c,$cb,$0c,$c2,$0c,$0c
	.db	$cb,$61,$0a,$c2,$0a,$0a,$0a,$0a,$cb,$0a,$c2,$0a,$0a
	.db	$cb,$65,$03,$c2,$03,$03,$03,$03,$cb,$03,$c2,$03,$03
	.db	$cb,$60,$0c,$c2,$0c,$0c,$0c,$0c,$cb,$0c,$c2,$0c,$0c
	.db	$cb,$64,$0c,$c2,$0c,$0c,$0c,$0c,$cb,$0c,$c2,$0c,$0c
	.db	$cb,$61,$0f,$c2,$0f,$0f,$0f,$cb,$64,$0e,$c2,$0e,$0e,$0e
	.db	$ff

LEVELSAV0
	.db	$80,$0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
	.db	$80,$10,$10,$10,$10,$10,$10,$10,$10
	.db	$ff,$00
LEVELSAV1
	.db	$81,$0e,$0e,$0f,$0f,$83,$0f,$0f,$0f,$0f
	.db	$ff,$00

s0d
	.db	$ca
	.db	$8c,$6e,$00,$01,$02,$03,$88,$04,$05
	.db	$8c,$06,$05,$88,$04,$8c,$03,$02,$88,$01
	.db	$ff
s0e
	.db	$c1,$84,$66,$0c,$07,$88,$0a,$84,$0c,$88,$00,$00
	.db	$84,$0c,$0a,$07,$0a,$0c,$88,$00
	.db	$84,$00,$0c,$0a,$07,$88,$0a,$84,$0c,$88,$00
	.db	$84,$0c,$0a,$07,$0a,$0c,$88,$00
	.db	$84,$0c,$07,$88,$0a,$84,$0c,$88,$00,$00
	.db	$84,$0c,$0a,$07,$0a,$0c,$88,$00
	.db	$88,$08,$84,$08,$03,$08,$0a,$0c,$88,$0a,$84,$05,$0a,$0c
	.db	$82,$0e,$0f,$84,$0e,$0c,$0a
	.db	$ff
s0f
	.db	$c1,$84,$6f,$0c,$07,$88,$0a,$84,$0c,$88,$00,$00
	.db	$84,$0c,$0a,$07,$0a,$0c,$88,$00
	.db	$84,$00,$0c,$0a,$07,$88,$0a,$84,$0c,$88,$00
	.db	$84,$0c,$0a,$07,$0a,$0c,$88,$00
	.db	$84,$0c,$07,$88,$0a,$84,$0c,$88,$00,$00
	.db	$84,$0c,$0a,$07,$0a,$0c,$88,$00
	.db	$88,$08,$84,$08,$03,$08,$0a,$0c,$88,$0a,$84,$05,$0a,$0c
	.db	$82,$0e,$0f,$84,$0e,$0c,$0a
	.db	$ff
s10
	.db	$ca,$88,$6e,$00
	.db	$c3,$84,$70,$0d
	.db	$ca,$88,$6e,$01
	.db	$c3,$84,$70,$0d
	.db	$ca,$88,$6e,$02
	.db	$c3,$84,$70,$0d
	.db	$ca,$88,$6e,$03
	.db	$c3,$84,$70,$0d
	.db	$ca,$88,$6e,$04
	.db	$ca,$88,$6e,$05
	.db	$ca,$88,$6e,$06
	.db	$c3,$84,$70,$0d
	.db	$ca,$88,$6e,$05
	.db	$c3,$84,$70,$0d
	.db	$ca,$88,$6e,$04
	.db	$ca,$88,$6e,$03
	.db	$c3,$84,$70,$0d
	.db	$ca,$88,$6e,$02
	.db	$c3,$84,$70,$0d
	.db	$ca,$88,$6e,$01
	.db	$ff

LEVELRIV0	.db	$80,$11,$81,$13,$82,$14,$14,$14,$14,$80,$13
	.db	$ff,$00

LEVELRIV1	.db	$80,$12,$12,$82,$12,$12,$12,$12,$12,$12,$81,$12,$12
	.db	$ff,$00
s11
	.db	$cb,$84,$66,$0c
	.db	$cb,$0d
	.db	$cb,$0c
	.db	$cb,$0d
	.db	$cb,$0f
	.db	$cb,$11,$c2,$0f
	.db	$cb,$0c
	.db	$cb,$0d
	.db	$cb,$0c
	.db	$cb,$0a
	.db	$cb,$0c
	.db	$cb,$08
	.db	$cb,$07,$c2,$08,$07
	.db	$cb,$0c
	.db	$cb,$0d
	.db	$cb,$0c
	.db	$cb,$0d
	.db	$cb,$0f
	.db	$cb,$11,$c2,$0f
	.db	$cb,$0c
	.db	$cb,$0d
	.db	$cb,$0c
	.db	$cb,$0a
	.db	$cb,$0c
	.db	$cb,$11
	.db	$cb,$13
	.db	$cb,$14
	.db	$cb,$13

	.db	$cb,$18
	.db	$cb,$19
	.db	$cb,$18
	.db	$cb,$19
	.db	$cb,$1b
	.db	$cb,$1d,$c2,$1b
	.db	$cb,$18
	.db	$cb,$19
	.db	$cb,$18
	.db	$cb,$16
	.db	$cb,$18
	.db	$cb,$14
	.db	$cb,$13,$c2,$14,$13
	.db	$cb,$18
	.db	$cb,$19
	.db	$cb,$18
	.db	$cb,$19
	.db	$cb,$1b
	.db	$cb,$1d,$c2,$1b
	.db	$cb,$18
	.db	$cb,$19
	.db	$cb,$18
	.db	$cb,$16
	.db	$cb,$18
	.db	$cb,$14
	.db	$cb,$13
	.db	$cb,$0d
	.db	$cb,$0a
	.db	$ff
s12
	.db	$cc,$8c,$67,$00,$84,$00,$8c,$68,$00,$84,$67,$00
	.db	$cc,$8c,$67,$00,$84,$00,$88,$68,$01,$84,$66,$03,$67,$03
	.db	$cc,$8c,$67,$00,$84,$00,$8c,$68,$00,$84,$67,$00
	.db	$cc,$8c,$67,$00,$84,$00,$88,$68,$05,$84,$66,$07,$67,$0c
	.db	$ff
s13
	.db	$cb,$90,$71,$00,$00,$07,$07,$0c,$0c,$13,$13,$18,$18
	.db	$13,$13,$0c,$0c,$07,$07
	.db	$ff
s14
	.db	$cb,$84,$72,$0c
	.db	$cb,$84,$0d
	.db	$cb,$84,$0c
	.db	$cb,$84,$0d
	.db	$cb,$84,$0f
	.db	$cb,$84,$11,$c2
	.db	$cb,$84,$0c
	.db	$cb,$84,$0d
	.db	$cb,$84,$0c
	.db	$cb,$84,$0a
	.db	$cb,$84,$0d
	.db	$cb,$90,$fd,$8f,$0c,$13
	.db	$cb,$84,$0c
	.db	$cb,$84,$0d
	.db	$cb,$84,$0c
	.db	$cb,$84,$0d
	.db	$cb,$84,$0f
	.db	$cb,$84,$11,$c2
	.db	$cb,$84,$14
	.db	$cb,$84,$13
	.db	$cb,$84,$18
	.db	$cb,$84,$19
	.db	$cb,$84,$1b
	.db	$cb,$88,$fd,$4f,$19,$18
	.db	$cb,$88,$fd,$4f,$16,$18
	.db	$ff

LEVELJUN0
	.db	$84,$15,$15,$15,$15,$15,$15,$15,$15
	.db	$84,$15,$82,$18,$80,$18,$82,$18
	.db	$ff,$00
LEVELJUN1
	.db	$84,$16,$16,$82,$16,$16,$80,$16,$16,$82,$16,$16
	.db	$84,$16,$16,$82,$16,$16,$80,$16,$16,$82,$16,$16
	.db	$84,$17
	.db	$ff,$00

s15
	.db	$cb
	.db	$82,$67,$0a
	.db	$82,$66,$0c
	.db	$84,$67,$0c
	.db	$84,$68,$0c
	.db	$82,$66,$0c
	.db	$86,$67,$00
	.db	$84,$67,$00
	.db	$84,$68,$00
	.db	$84,$67,$00
	.db	$82,$67,$0a
	.db	$82,$66,$0c
	.db	$84,$67,$0c
	.db	$84,$68,$0c
	.db	$82,$66,$0c
	.db	$84,$67,$00
	.db	$82,$66,$00
	.db	$84,$67,$03
	.db	$84,$68,$05
	.db	$84,$67,$07
	.db	$ff
s16
	.db	$c0,$82,$6b,$13,$c2,$c3,$c0,$c2,$c3,$c0,$c2,$c3
	.db	$c0,$c2,$c3,$c0,$88
	.db	$ff
s17
	.db	$c0,$82,$66,$18,$18,$16,$c2,$18,$c0,$84,$12,$82,$11
	.db	$cd,$86,$0f
	.db	$c0,$84,$0c,$82,$0a,$cd,$86,$0c
	.db	$c0,$82,$0f,$c2,$0c
	.db	$cd,$84,$0f
	.db	$c0,$82,$11,$c2,$0f
	.db	$c0,$82,$12
	.db	$cd,$86,$11
	.db	$c0,$82,$0f,$c2,$11,$0f,$11,$13,$16

	.db	$c0,$82,$18,$18,$16,$c2,$18,$c0,$84,$12,$82,$11
	.db	$cd,$86,$0f
	.db	$c0,$84,$0c,$82,$0a,$cd,$86,$0c
	.db	$c0,$82,$0f,$0f
	.db	$c0,$82,$11,$c2,$0f
	.db	$c0,$82,$12
	.db	$c0,$82,$11,$c2,$12
	.db	$cd,$86,$fd,$1f,$0f,$11
	.db	$c0,$82,$0f,$c2,$11,$0f,$12,$13,$16

	.db	$c0,$82,$18,$18,$16,$c2,$18,$c0,$84,$12,$82,$11
	.db	$cd,$86,$0f
	.db	$c0,$84,$0c,$82,$0a,$0c,$11,$12
	.db	$c0,$82,$13
	.db	$c0,$82,$16
	.db	$c0,$82,$18,$c2,$16
	.db	$cd,$84,$1a
	.db	$c0,$82,$1b
	.db	$cd,$86,$1a
	.db	$c0,$82,$18,$c2,$1a
	.db	$c0,$82,$16,$13,$16,$18

	.db	$c0,$82,$1d
	.db	$c0,$82,$1d
	.db	$c0,$82,$1b
	.db	$cd,$86,$18
	.db	$c0,$82,$1d
	.db	$c0,$82,$1d
	.db	$c0,$82,$1b
	.db	$c0,$82,$18,$c2,$1b
	.db	$cd,$84,$16
	.db	$c0,$82,$18,$1b,$1d
	.db	$c0,$82,$1e,$1f,$22,$1e,$1d,$1b,$18,$16,$13,$12
	.db	$11,$0f,$0c,$06,$05,$03
	.db	$ff
s18
	.db	$82,$67,$00
	.db	$82,$66,$0c
	.db	$84,$67,$00
	.db	$84,$68,$07
	.db	$82,$66,$0c
	.db	$86,$67,$00
	.db	$84,$67,$07
	.db	$84,$68,$0c
	.db	$84,$67,$07
	.db	$82,$67,$00
	.db	$82,$66,$0c
	.db	$84,$67,$00
	.db	$84,$68,$07
	.db	$82,$66,$0c
	.db	$84,$67,$00
	.db	$82,$66,$07
	.db	$84,$67,$0c
	.db	$84,$68,$07
	.db	$84,$67,$0c
	.db	$ff

LEVELMIL0
	.db	$80,$19,$19,$83,$19,$19
	.db	$ff,$00
LEVELMIL1
	.db	$80,$1a,$83,$1a,$80,$1b,$1b,$83,$1b,$1b
	.db	$ff,$00


s19
	.db	$c9,$82
	.db	$67,$00
	.db	$66,$0c
	.db	$66,$0a
	.db	$67,$00
	.db	$68,$0c
	.db	$66,$00
	.db	$67,$0a
	.db	$66,$00
	.db	$66,$0c
	.db	$66,$00
	.db	$67,$0a
	.db	$66,$0c
	.db	$68,$00
	.db	$67,$0a
	.db	$66,$00
	.db	$66,$0c
	.db	$67,$00
	.db	$66,$0c
	.db	$66,$0a
	.db	$67,$00
	.db	$68,$0c
	.db	$66,$00
	.db	$67,$0a
	.db	$66,$00
	.db	$73,$0a
	.db	$67,$00
	.db	$73,$0a
	.db	$74,$09
	.db	$68,$00
	.db	$75,$07
	.db	$68,$00
	.db	$73,$0a
	.db	$67,$00
	.db	$66,$0c
	.db	$66,$0a
	.db	$67,$00
	.db	$68,$0c
	.db	$66,$00
	.db	$67,$0a
	.db	$66,$00
	.db	$66,$0c
	.db	$66,$00
	.db	$67,$0a
	.db	$66,$0c
	.db	$68,$00
	.db	$67,$0a
	.db	$66,$00
	.db	$66,$0c
	.db	$67,$00
	.db	$66,$0c
	.db	$66,$0a
	.db	$67,$00
	.db	$68,$0c
	.db	$66,$00
	.db	$67,$0a
	.db	$66,$00

	.db	$73,$0a
	.db	$68,$00
	.db	$73,$0a
	.db	$74,$09
	.db	$68,$00
	.db	$75,$07
	.db	$68,$00
	.db	$75,$09
	.db	$ff
s1a
	.db	$c1,$b0,$63,$16
	.db	$c1,$86,$61,$16
	.db	$c1,$82,$63,$18,$c3,$61,$16,$18
	.db	$c1,$b4,$63,$16
	.db	$c1,$86,$61,$1b
	.db	$c1,$82,$63,$18,$c3,$61,$1b,$18
	.db	$c1,$b4,$63,$16
	.db	$c1,$86,$61,$16
	.db	$c1,$82,$63,$18,$c3,$61,$16,$18
	.db	$c1,$b4,$63,$16
	.db	$c1,$88,$63,$17
	.db	$c1,$84,$63,$18,$c3,$17
	.db	$ff
s1b
	.db	$c1,$82,$63,$16,$c3
	.db	$c1,$82,$63,$16,$c3
	.db	$c1,$82,$63,$16
	.db	$c1,$82,$66,$1d
	.db	$c1,$82,$66,$1b
	.db	$c1,$86,$61,$16
	.db	$c1,$82,$61,$16,$c3
	.db	$c1,$84,$61,$16
	.db	$c1,$82,$64,$1a,$c3,$61,$16
	.db	$c1,$82,$63,$18,$c3,$64,$1a,$63,$18
	.db	$c1,$82,$64,$15,$c3,$63,$18,$64,$15
	.db	$c1,$90,$63,$13,$c3,$84

	.db	$c1,$82,$63,$16,$c3
	.db	$c1,$82,$63,$16,$c3
	.db	$c1,$82,$63,$16
	.db	$c1,$82,$66,$1d
	.db	$c1,$82,$66,$1b
	.db	$c1,$86,$61,$16
	.db	$c1,$82,$61,$16,$c3
	.db	$c1,$84,$61,$16
	.db	$c1,$82,$64,$1a,$c3,$61,$16
	.db	$c1,$84,$63,$18
	.db	$c1,$84,$64,$15
	.db	$c1,$84,$63,$18
	.db	$c1,$84,$61,$1d
	.db	$c1,$86,$6c,$1b,$c3,$82
	.db	$c1,$86,$6c,$1d,$c3,$82,$1b
	.db	$ff

KNOCKJIN2	.db	$80,$1c,$ff,$00
KNOCKJIN3	.db	$80,$1d,$ff,$00

s1c
	.db	$c2,$82,$66,$18,$19,$1f,$20
	.db	$83,$19,$1f,$20,$24
	.db	$84,$1f,$20,$24,$25
	.db	$85,$20,$24,$25,$2b
	.db	$84,$1f,$20,$24,$25
	.db	$83,$19,$1f,$20,$24
	.db	$ff
s1d
	.db	$ce,$84,$60,$05,$04,$86,$05,$04,$88,$05,$04
	.db	$8a,$05,$04,$88,$05,$04,$86,$05,$04
	.db	$ff
GAMEOVER0
	.db	$80,$1e,$fe
GAMEOVER1
	.db	$80,$1f,$fe
GAMEOVER2
	.db	$80,$20,$fe
GAMEOVER3
	.db	$80,$21,$fe

s1e
	.db	$c1,$84,$67,$0c
	.db	$66,$0c
	.db	$68,$0c
	.db	$66,$08
	.db	$66,$08
	.db	$67,$08
	.db	$68,$07
	.db	$67,$07
	.db	$88,$68,$00,$e8,$00,$e8,$96,$00
	.db	$ff
s1f
	.db	$c1,$84,$60,$18,$64,$18,$60,$18
	.db	$61,$14,$65,$14,$61,$14,$6c,$13,$62,$13
	.db	$88,$76,$0c,$e8,$00,$e8,$97,$00
	.db	$ff
s20
	.db	$c1,$84,$66,$1f,$20,$1f,$1b,$1d,$82,$1b,$81,$1d,$1b
	.db	$84,$1a,$1b
	.db	$88,$18,$e8,$0c,$e8,$98,$00
	.db	$ff
s21
	.db	$c8,$84,$77,$04
	.db	$c8
	.db	$c9
	.db	$c8
	.db	$c8
	.db	$c8
	.db	$c9
	.db	$c8
	.db	$c9,$84,$04,$ec,$84,$05,$ec,$84,$05
	.db	$ff

WONGAME0	.db	$80,$22,$fe
WONGAME1	.db	$80,$23,$fe
WONGAME2	.db	$80,$24,$fe
WONGAME3	.db	$80,$25,$fe

s22
	.db	$ca,$84,$68,0
	.db	$82,0,0,$84,0,0,0,2,4,7,$86,10,$82,9,10,$84,14,$81,4,7,$84,12
	.db	$ff
s23
	.db	$cb,$84,$6d,$18,$82,$18,$18,$84,$18,$18,$1f,$18,$1f,$24
	.db	$86,$22,$82,$21,$22,$86,$26,$86,$24
	.db	$ff
s24
	.db	$c0,$84,$64,$10,$82,$10,$10,$84,$10,$10,$61,$18,$64,$10
	.db	$61,$18,$64,$1c,$86,$64,$1a,$82,$63,$18,$64,$1a
	.db	$86,$63,$1d,$85,$64,$1c
	.db	$ff
s25
	.db	$ca,$84,$66,4
	.db	$82,4,4,$84,4,4,4,4,4,4,$86,4,$82,4,4,$84,4,$81,4,4,$84,4
	.db	$ff
MAPJINGL0	.db	$8c,$28,$28,$89,$28,$28,$86,$28,$28,$89,$28,$28,$ff,$00
MAPJINGL1	.db	$8c,$27,$27,$89,$27,$27,$86,$27,$27,$89,$27,$27,$ff,$00
MAPJINGL2	.db	$8c,$26,$26,$89,$26,$26,$86,$26,$26,$89,$26,$26,$ff,$00
MAPJINGL3	.db	$80,$29,$ff,$00

s26
	.db	$cb,$8c,$6d,$00
	.db	$05
	.db	$07
	.db	$0c
	.db	$0f
	.db	$84,$07
	.db	$ff
s27
	.db	$e4
	.db	$cb,$8c,$6d,$05
	.db	$07
	.db	$0c
	.db	$11
	.db	$82,$0e,$81,$0f,$89,$0e
	.db	$ff
s28
	.db	$e8
	.db	$cb,$8c,$6d,$07
	.db	$0c
	.db	$11
	.db	$13
	.db	$88,$0a
	.db	$ff
s29
	.db	$cf,$88,$66,4,$84,4,$88,4,4,$84,4
	.db	$ff

UHOHBOSS0		.db	$80,$2a,$fe

s2a		.db	$c7,$bf,$78,$15
		.db	$ff

ENDOFLEV0	.db	$8c,$2b,$fe
ENDOFLEV1	.db	$8c,$2c,$2e,$fe
ENDOFLEV2	.db	$8c,$2d,$2e,$fe
ENDOFLEV3	.db	$80,$2f,$fe

s2b	.db	$c0,$81,$66,$0c
s2e	.db	$0f,$11,$12,$11,$12,$13,$16,$13,$16,$18,$1b,$18,$1b,$1d,$1e
	.db	$85,$1f,$81,$22,$1e,$1d,$1b,$18,$16,$13,$16,$18,$12,$11
	.db	$0f,$12,$11,$0f,$11,$0f,$0c,$07
	.db	$88,$fd,$62,$0a,$09
	.db	$ff
s2c	.db	$e3
	.db	$c3,$81,$66,$0c
	.db	$ff
s2d	.db	$e6
	.db	$c6,$81,$66,$0c
	.db	$ff
s2f
	.db	$c2,$82,$66,$02,$02,$01,$02
	.db	$81,$00,$01,$82,$02
	.db	$81,$00,$01,$82,$02
	.db	$02,$01,$02,$02
	.db	$81,$00,$02,$82,$01
	.db	$81,$00,$01,$82,$02
	.db	$02,$02,$01,$02
	.db	$81,$00,$01,$82,$02
	.db	$81,$00,$01,$82,$02
	.db	$ff


clearaud		.db	$00,$fe					;EMPTY SFX
s00		.db	$f0,$f0,$f0,$f0,$ff
sex



CHRCONVTAB	.db	0,44,-1,-1,46,47,-1,-1,-1,-1	 	; SPACE !
	.db	37,-1,42,45,41,-1,1,2,3,4							; * , - . 0123
	.db	5,6,7,8,9,10,-1,-1,-1,-1    		; 456789
	.db	-1,43,-1,11,12,13,14,15,16,17	; ? ABCDEFG
	.db	18,19,20,21,22,23,24,25,26,27	; HIJKLMNOPQ
	.db	28,29,30,31,32,33,34,35,36				; RSTUVWXYZ
	.db	-1,-1,-1,-1,-1,-1,39,40,38				; a=(c) b=(r) c=tm

SOUNDTEXT	.db	0,6,6
	.db	"AUDIO NO.  -"
	.db	0,6,8
	.db	"SAMPLE NO. -"
	.db	-1

TEXTCHARS	.incbin "TEXTCHRS.MUS.bin" ;INCLUDE C:\JEROEN\TESTROOM\TEXTCHRS.MUS

SAMTAB	;DW	SAM1,SAM1E-SAM1
	;DW	SAM2,SAM2E-SAM2

SAM1	;INCBIN c:\JEROEN\MDRIVE\SHADUP.sam
SAM1E
SAM2	;INCBIN c:\JEROEN\MDRIVE\AHHVOX.sam
SAM2E

SAMSPEED	.DW	8


*** WORKSPACE ***

;	org	#c000

.ramsection "Vars" bank 0 slot 3                               ; M

VARIABLES	dsb 35*4 ;,0

ssslo	db	;0
ssshi	db	;0

psgreg7	db	;00111111b

noisenabl	db	;00111111b
noiseout	db	;0

KEYS	DB	;0
INTFLAG	db	;0

CHRPOS	DW	;0

DIGITS	dsb 7 ;DM	"000000"
	;.db	-1

ATNO	db	;0
SAMNO	db	;0

NUMBUFF	dsb 3 ;.db	0,0,0

MONOFF	db	;0

;	END	START
.ends                                                          ; M

;==============================================================
; End
;==============================================================

.bank 1 slot 1
.sdsctag 1.00,name,sdscnotes,author                            ; M
.orga $7f00                                                    ; M
name:                                                          ; M
.db "A-Team Music",0                                           ; M
.orga $7f10                                                    ; M
author:                                                        ; M
.db "Jeroen Tel",0                                             ; M
.orga $7f20                                                    ; M
sdscnotes:                                                     ; M
.db "Compiled version of Jeroen Tel's music engine/sound "     ; M
.db "test for \"The A-Team\", an unfinished game by Probe. "   ; M
.db "Converted to a modern assembler dialect and bugfixed "    ; M
.db "by Maxim.",0
